package com.brilliance.swift.element2mx.camt060001;

import com.alibaba.fastjson.JSONArray;
import com.brilliance.swift.element2mx.AbstractElement2MxCreator;
import com.brilliance.swift.util.StringUtil;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;

public class Element2MxCamt060001Creator extends AbstractElement2MxCreator {

    @Override
    protected boolean isArray(String key) {
        if ("rptgReq".equals(key)||"flrLmt".equals(key)) {
            return true;
        }
        return false;
    }

    @Override
    protected void rebuildProperties() {
        Set<Object> sets = properties.keySet();
        for (Object obj : sets) {
            String keyValue = properties.getProperty((String) obj);
            if (keyValue.indexOf("(") > -1 && keyValue.indexOf(")") > -1) {
                String condition = keyValue.substring(keyValue.indexOf("(")+1, keyValue.indexOf(")"));
                String type = "";
                if (StringUtil.isNotEmpty(condition)) {
                    type = condition.split(":")[1];
                }
                String path = keyValue.substring(keyValue.indexOf(")")+2);
                if (StringUtil.isNotEmpty(path) && path.indexOf("&") > -1) {
                    path = path.substring(0, path.indexOf("&"));
                }
                String type2 = "";
                String path2 = "";
                if (path.indexOf("(") > -1 && path.indexOf(")") > -1) {
                    int begin = path.indexOf("(");
                    int end = path.indexOf(")");
                    String condition2 = path.substring(path.indexOf("(") + 1, path.indexOf(")"));
                    if (StringUtil.isNotEmpty(condition)) {
                        type2 = condition2.split(":")[1];
                    }
                    path2 = path.substring(end + 2);
                }
                if (StringUtil.isNotEmpty(type) && StringUtil.isNotEmpty(path)) {
                    if(StringUtil.isEmpty(path2)){
                        properties.put(obj, "@addRptReq&"+type+"&"+path);
                    }else {
                        properties.put(obj, "@addRptReq&"+type+"&"+path2+"&"+type2);
                    }
                }
            }
        }
    }
    public void addRptReq(HashMap<String,Object> maps, Object obj) {
        List<Object> objList = (List<Object>)obj;
        Object value = objList.get(0);
        String msgNameId = (String) objList.get(1);
        String valuePath = (String) objList.get(2);
        String type2 = "";
        if(objList.size()>3){
            type2 = (String) objList.get(3);
        }
        Object rptObj = getObj(maps, "acctRptgReq.rptgReq");
        if (rptObj == null) {
            JSONArray jsonArray = new JSONArray();
            putObj(maps, "acctRptgReq.rptgReq", jsonArray);
            rptObj = jsonArray;
        }
        if (rptObj != null) {
            JSONArray jsonArray = (JSONArray)rptObj;
            Map<String, Object> rptMap = null;
            for (int i=0; i<jsonArray.size(); i++) {
                Map<String, Object> rptTmpMaps = (Map<String, Object>)jsonArray.get(i);
                if (msgNameId.equals(getObj(rptTmpMaps, "acctRptgReq.rptgReq.reqdMsgNmId"))) {
                    rptMap = rptTmpMaps;
                    break;
                }
            }
            if (rptMap == null) {
                rptMap = new HashMap<String, Object>();
                putObj(rptMap, "acctRptgReq.rptgReq.reqdMsgNmId", msgNameId);
                jsonArray.add(rptMap);
            }
//            putObj(rptMap, valuePath, value);
            if(StringUtil.isEmpty(type2)){
                putObj(rptMap, valuePath, value);
            }else {
                Object flrObj = getObj(rptMap, "reqdTxTp.flrLmt");
                if(flrObj == null){
                    JSONArray jsonArray2 = new JSONArray();
                    putObj(rptMap, "reqdTxTp.flrLmt", jsonArray2);
                    flrObj = jsonArray2;
                }
                if(flrObj!=null){
                    JSONArray jsonArray2 = (JSONArray)flrObj;
                    Map<String, Object> flrMap = null;
                    for (int i=0; i<jsonArray2.size(); i++) {
                        Map<String, Object> flrTmpMaps = (Map<String, Object>)jsonArray2.get(i);
                        if (type2.equals(getObj(flrTmpMaps, "cdtDbtInd"))) {
                            flrMap = flrTmpMaps;
                            break;
                        }
                    }
                    if (flrMap == null) {
                        flrMap = new HashMap<String, Object>();
                        putObj(flrMap, "cdtDbtInd", type2);
                        jsonArray2.add(flrMap);
                    }
                    putObj(flrMap, valuePath, value);
                }
            }
        }
    }



}
