package com.brilliance.swift.mt2mx.camt029001;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.mt2mx.AbstractMt2MxCreator;
import com.brilliance.swift.mt2mx.Mt2MxContextIdentifier;
import com.brilliance.swift.mt2mx.Mt2MxParseField;
import com.brilliance.swift.mt2mx.camt029001.impl.*;
import com.brilliance.swift.util.MapUtil;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Mt2MxCamt029001Creator extends AbstractMt2MxCreator {

    @Override
    public void preProcess() {
        super.preProcess();
        jsonMaps.put("identifier", "camt.029.001.09");
        MapUtil.puts(jsonMaps, "appHdr/msgDefIdr", "camt.029.001.09");
        Map<String, Object> txInfAndStsMaps = new HashMap<String, Object>();
        Map<String, Object> cxlDtlsMaps = MapUtil.adds("txInfAndSts", txInfAndStsMaps);
        MapUtil.adds(jsonMaps, "rsltnOfInvstgtn/cxlDtls", cxlDtlsMaps);
        MapUtil.puts(jsonMaps, "rsltnOfInvstgtn/sts", new HashMap<String, Object>());
        //Default Values
        MapUtil.puts(jsonMaps, "rsltnOfInvstgtn/assgnmt/creDtTm", getCreateDateStr());
        MapUtil.puts(txInfAndStsMaps, "rslvdCase/cretr/agt/finInstnId/nm", Mx2MtConstants.MT_TO_MX_DEFAULT_VALUE);
        MapUtil.adds(txInfAndStsMaps, "rslvdCase/cretr/agt/finInstnId/pstlAdr/adrLine", Mx2MtConstants.MT_TO_MX_DEFAULT_VALUE);
        MapUtil.puts(txInfAndStsMaps, "orgnlGrpInf/orgnlMsgId", Mx2MtConstants.MT_TO_MX_DEFAULT_VALUE);
        //TR002
        String sendBic = (String) context.get(Mt2MxContextIdentifier.MT_SEND_BIC, true);
        if (StringUtil.isNotEmpty(sendBic)) {
            MapUtil.puts(jsonMaps, "rsltnOfInvstgtn/assgnmt/assgnr/agt/finInstnId/bicfi", sendBic);
        }
        String receiverBic = (String) context.get(Mt2MxContextIdentifier.MT_RECEIVE_BIC, true);
        if (StringUtil.isNotEmpty(receiverBic)) {
            MapUtil.puts(jsonMaps, "rsltnOfInvstgtn/assgnmt/assgne/agt/finInstnId/bicfi", receiverBic);
        }
        AbstractMT abstractMT = context.get(AbstractMT.class);
        String mtUETR = abstractMT.getSwiftMessage().getUETR();
        if (StringUtil.isNotEmpty(mtUETR)) {
            txInfAndStsMaps.put("orgnlUETR", mtUETR);
        }
    }

    @Override
    public List<Mt2MxParseField> getParseFieldList() {
        List<Mt2MxParseField> list = new ArrayList<Mt2MxParseField>();
        list.add(new Camt029001Parse20Field());
        list.add(new Camt029001Parse21Field());
        list.add(new Camt029001Parse11RField());
        list.add(new Camt029001Parse76Field());
        list.add(new Camt029001Parse77AField());
        list.add(new Camt029001Parse79Field());
        return list;
    }
}
