package com.brilliance.swift.mt2mx.camt029001.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.camt029001.AbstractMt2MxCamt029001ParseField;
import com.brilliance.swift.util.MapUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field11R;
import com.prowidesoftware.swift.model.mt.AbstractMT;

//这个域的作用就是将原始消息的名称和原始消息的创建时间存入map集合
public class Camt029001Parse11RField extends AbstractMt2MxCamt029001ParseField {

    private static final String NAME = "11R";

    @Override
    public void parseField() throws SwiftException {
        SwiftMessage swiftMessage = context.get(AbstractMT.class).getSwiftMessage();
        Tag tag11R = swiftMessage.getBlock4().getTagByName(NAME);
        if (tag11R == null) {
            MapUtil.puts(txInfAndStsMaps, "orgnlGrpInf/orgnlMsgNmId", Mx2MtConstants.MT_TO_MX_DEFAULT_VALUE);
        } else {
            Field11R field11R = (Field11R) tag11R.asField();
            //TR003
            MapUtil.puts(txInfAndStsMaps, "orgnlGrpInf/orgnlMsgNmId", getMxType(field11R.getMT()));
            //TR001
            String mxDate = mt_to_mxDate(field11R.getDate()) + "T00:00:00+00:00";
            MapUtil.puts(txInfAndStsMaps, "orgnlGrpInf/orgnlCreDtTm", mxDate);
        }
    }
}
