package com.brilliance.swift.mt2mx.camt029001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.camt029001.AbstractMt2MxCamt029001ParseField;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class Camt029001Parse77AField extends AbstractMt2MxCamt029001ParseField {

    private static final String NAME = "77A";

    @Override
    public void parseField() throws SwiftException {
        SwiftMessage swiftMessage = context.get(AbstractMT.class).getSwiftMessage();
        Tag tag77A = swiftMessage.getBlock4().getTagByName(NAME);
        String mtUETR = swiftMessage.getUETR();
        //TR004
        if (tag77A == null) {
            if (StringUtil.isEmpty(mtUETR)) {
                //Translation Preconditions
                buildSTErrorInfo(76, "Block3/EndToEndReference/UniqueEndToEndTransactionReference", null);
            }
        } else {
            String lineRgx = "\\r?\\n";
            String mtField77A = tag77A.asField().getValue();
            String[] lines = mtField77A.split(lineRgx);
            String field77AUETR = extractLines(lines, "/UETR/", "//", 50,true);
            String uetrRgx = "/UETR/([a-f0-9]{8}-[a-f0-9]{4}-4[a-f0-9]{3}-[89ab][a-f0-9]{3}-[a-f0-9]{12})";
            Matcher uetrMatcher = Pattern.compile(uetrRgx).matcher(field77AUETR);
            field77AUETR = uetrMatcher.find() ? uetrMatcher.group(1) : "";
            if (StringUtil.isEmpty(mtUETR)) {
                if (field77AUETR.length() > 0) {
                    txInfAndStsMaps.put("orgnlUETR", field77AUETR);
                } else {
                    //Translation Preconditions
                    buildSTErrorInfo(76, "Block3/EndToEndReference/UniqueEndToEndTransactionReference", null);
                }
            }
            String field77AUETRLines = extractLinesAsIs(lines, "/UETR/", "//", true);
            String field77AJoin = StringUtil.joinString(lines, "");
            if (field77AJoin.replace(field77AUETRLines, "").length() > 0) {
                buildSTErrorInfo(115, "Block4/:77A:", null);
            }
        }
    }
}
