package com.brilliance.swift.mt2mx.camt052001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.camt052001.AbstractMt2MxCamt052001ParseField;
import com.brilliance.swift.util.MapUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field25P;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.HashMap;
import java.util.Map;

//存储的是账号信息
public class Camt052001Parse25Field extends AbstractMt2MxCamt052001ParseField {

    private static final String NAME_25 = "25";

    private static final String NAME_25P = "25P";

    @Override
    public void parseField() throws SwiftException {
        SwiftMessage swiftMessage = context.get(AbstractMT.class).getSwiftMessage();
        Tag tag25 = swiftMessage.getBlock4().getTagByName(NAME_25);
        Tag tag25p = swiftMessage.getBlock4().getTagByName(NAME_25P);
        Map<String, Object> acctMap = new HashMap<String, Object>();
        if (tag25 != null) {
            mt_to_mxAccount35(tag25.getValue(), acctMap, "BkToCstmrStmt/Rpt/Acct/Id/IBAN");
        }
        if (tag25p != null) {
            Field25P field25P = (Field25P) tag25p.asField();
            mt_to_mxAccount35(field25P.getAccount(), acctMap, "BkToCstmrAcctRpt/Rpt/Acct/Id/Othr/Id");
            MapUtil.puts(rptMaps, "acct/ownr/id/orgId/anyBIC", field25P.getBIC());
        }
        MapUtil.puts(rptMaps, "acct", acctMap);
    }
}
