package com.brilliance.swift.mt2mx.camt052001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.camt052001.AbstractMt2MxCamt052001ParseField;
import com.brilliance.swift.util.MapUtil;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field28C;
import com.prowidesoftware.swift.model.mt.AbstractMT;

//这个域存放了对账单号码和分页序号将这2个值存入map集合中
public class Camt052001Parse28CField extends AbstractMt2MxCamt052001ParseField {

    private static final String NAME = "28C";

    @Override
    public void parseField() throws SwiftException {
        AbstractMT abstractMT = context.get(AbstractMT.class);
        Tag tag28C = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME);
        if (tag28C != null) {
            Field28C field28C = (Field28C) tag28C.asField();
            MapUtil.puts(rptMaps, "rptPgntn/pgNb", field28C.getSequenceNumber());
            MapUtil.puts(rptMaps, "lglSeqNb", field28C.getStatementNumber());
            if("1".equals(field28C.getSequenceNumber())){
                MapUtil.puts(rptMaps, "rptPgntn/lastPgInd", Boolean.TRUE);
            }
        }
    }
}
