package com.brilliance.swift.mt2mx.camt052001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.camt052001.AbstractMt2MxCamt052001ParseField;
import com.brilliance.swift.util.MapUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field34F;
import com.prowidesoftware.swift.model.mt.AbstractMT;

//这个域是最低金额维护，存储在map集合中是只存币种
public class Camt052001Parse34FField extends AbstractMt2MxCamt052001ParseField {

    private static final String NAME = "34F";

    @Override
    public void parseField() throws SwiftException {
        SwiftMessage swiftMessage = context.get(AbstractMT.class).getSwiftMessage();
        Tag tag34F = swiftMessage.getBlock4().getTagByName(NAME);
        if (tag34F != null) {
            Field34F field34F = (Field34F) tag34F.asField();
            MapUtil.puts(rptMaps, "acct/ccy", field34F.getCurrency());
        }
    }
}
