package com.brilliance.swift.mt2mx.camt052001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.camt052001.AbstractMt2MxCamt052001ParseField;
import com.brilliance.swift.util.MapUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field90C;
import com.prowidesoftware.swift.model.mt.AbstractMT;
import com.prowidesoftware.swift.utils.SwiftFormatUtils;

import java.math.BigDecimal;

//这个域存储的是贷记笔数和金额
public class Camt052001Parse90CField extends AbstractMt2MxCamt052001ParseField {

    private static final String NAME = "90C";

    @Override
    public void parseField() throws SwiftException {
        SwiftMessage swiftMessage = context.get(AbstractMT.class).getSwiftMessage();
        Tag tag90C = swiftMessage.getBlock4().getTagByName(NAME);
        if (tag90C != null) {
            Field90C field90C = (Field90C) tag90C.asField();
            MapUtil.puts(rptMaps, "txsSummry/ttlCdtNtries/nbOfNtries", field90C.getNumber());
            Number number = SwiftFormatUtils.getNumber(field90C.getAmount());
            BigDecimal amt = new BigDecimal(number.toString()).stripTrailingZeros();
            MapUtil.puts(rptMaps, "txsSummry/ttlCdtNtries/sum", amt.toPlainString());
        }
    }
}