package com.brilliance.swift.mt2mx.camt052001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.camt052001.AbstractMt2MxCamt052001ParseField;
import com.brilliance.swift.util.MapUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field90D;
import com.prowidesoftware.swift.model.mt.AbstractMT;
import com.prowidesoftware.swift.utils.SwiftFormatUtils;

import java.math.BigDecimal;

////这个域存储的是借记笔数和金额
public class Camt052001Parse90DField extends AbstractMt2MxCamt052001ParseField {

    private static final String NAME = "90D";

    @Override
    public void parseField() throws SwiftException {
        SwiftMessage swiftMessage = context.get(AbstractMT.class).getSwiftMessage();
        Tag tag90D = swiftMessage.getBlock4().getTagByName(NAME);
        if (tag90D != null) {
            Field90D field90D = (Field90D) tag90D.asField();
            MapUtil.puts(rptMaps, "txsSummry/ttlDbtNtries/nbOfNtries", field90D.getNumber());
            Number number = SwiftFormatUtils.getNumber(field90D.getAmount());
            BigDecimal amt = new BigDecimal(number.toString()).stripTrailingZeros();
            MapUtil.puts(rptMaps, "txsSummry/ttlDbtNtries/sum", amt.toPlainString());
        }
    }
}
