package com.brilliance.swift.mt2mx.camt053001;

import com.brilliance.swift.mt2mx.AbstractMt2MxCreator;
import com.brilliance.swift.mt2mx.Mt2MxParseField;
import com.brilliance.swift.mt2mx.camt053001.impl.*;
import com.brilliance.swift.util.MapUtil;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Mt2MxCamt053001Creator extends AbstractMt2MxCreator {

    @Override
    public void preProcess() {
        super.preProcess();
        jsonMaps.put("identifier", "camt.053.001.08");
        MapUtil.puts(jsonMaps, "appHdr/msgDefIdr", "camt.053.001.08");
        Map<String, Object> stmtMaps = new HashMap<String, Object>();
        MapUtil.adds(jsonMaps, "bkToCstmrStmt/stmt", stmtMaps);
        MapUtil.puts(jsonMaps, "bkToCstmrStmt/grpHdr/creDtTm", getCreateDateStr());
        AbstractMT abstractMT = context.get(AbstractMT.class);
        String uetr = abstractMT.getSwiftMessage().getUETR();
        Map<String, Object> ntryMaps = new HashMap<String, Object>();
        MapUtil.adds(stmtMaps, "ntry", ntryMaps);
        Map<String, Object> ntryDtlsMaps = new HashMap<String, Object>();
        MapUtil.adds(ntryMaps, "ntryDtls", ntryDtlsMaps);
        Map<String, Object> txDtlsMaps = new HashMap<String, Object>();
        MapUtil.adds(ntryDtlsMaps, "txDtls", txDtlsMaps);
        if (StringUtil.isNotEmpty(uetr)) {
            MapUtil.puts(txDtlsMaps, "refs/uetr", uetr);
        }
    }

    @Override
    public List<Mt2MxParseField> getParseFieldList() {
        List<Mt2MxParseField> list = new ArrayList<Mt2MxParseField>();
        list.add(new Camt053001Parse20Field());
        list.add(new Camt053001Parse25Field());
        list.add(new Camt053001Parse28CField());
        list.add(new Camt053001Parse60Field());
        list.add(new Camt053001Parse61Field());
        list.add(new Camt053001Parse62Field());
        list.add(new Camt053001Parse64Field());
        list.add(new Camt053001Parse65Field());
        list.add(new Camt053001Parse86Field());
        return list;
    }
}
