package com.brilliance.swift.mt2mx.camt053001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.camt053001.AbstractMt2MxCamt053001ParseField;
import com.brilliance.swift.util.MapUtil;
import com.brilliance.swift.vo.common.BalanceTypeCode;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field64;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.HashMap;
import java.util.Map;

import static com.brilliance.swift.constants.Mx2MtConstants.DRCRMARK_C;
import static com.brilliance.swift.vo.common.CdtDbtCode.CRDT;
import static com.brilliance.swift.vo.common.CdtDbtCode.DBIT;

//有效余额
public class Camt053001Parse64Field extends AbstractMt2MxCamt053001ParseField {

    private static final String NAME = "64";

    @Override
    public void parseField() throws SwiftException {
        SwiftMessage swiftMessage = context.get(AbstractMT.class).getSwiftMessage();
        Tag tag64 = swiftMessage.getBlock4().getTagByName(NAME);
        if (tag64 != null) {
            Map<String, Object> balMap = new HashMap<String, Object>();
            MapUtil.adds(stmtMaps, "bal", balMap);
            MapUtil.puts(balMap, "tp/cdOrPrtry/cd", BalanceTypeCode.CLAV.value());
            Field64 field64 = (Field64) tag64.asField();
            balMap.put("cdtDbtInd", DRCRMARK_C.equals(field64.getDCMark()) ? CRDT.value() : DBIT.value());
            String mxDate = mt_to_mxDate(field64.getDate());
            MapUtil.puts(balMap, "dt/dt", mxDate);
            MapUtil.puts(balMap, "amt/ccy", field64.getCurrency());
            MapUtil.puts(balMap, "amt/value", field64.amount());
        }
    }
}
