package com.brilliance.swift.mt2mx.camt053001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.camt053001.AbstractMt2MxCamt053001ParseField;
import com.brilliance.swift.util.MapUtil;
import com.brilliance.swift.vo.common.BalanceTypeCode;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field65;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.HashMap;
import java.util.Map;

import static com.brilliance.swift.constants.Mx2MtConstants.DRCRMARK_C;
import static com.brilliance.swift.vo.common.CdtDbtCode.CRDT;
import static com.brilliance.swift.vo.common.CdtDbtCode.DBIT;

//某日有效余额
public class Camt053001Parse65Field extends AbstractMt2MxCamt053001ParseField {

    private static final String NAME = "65";

    @Override
    public void parseField() throws SwiftException {
        AbstractMT abstractMT = context.get(AbstractMT.class);
        if("950".equals(abstractMT.getMessageType())){
            return;
        }
        SwiftMessage swiftMessage = context.get(AbstractMT.class).getSwiftMessage();
        Tag tag65 = swiftMessage.getBlock4().getTagByName(NAME);
        if (tag65 != null) {
            Map<String, Object> balMap = new HashMap<String, Object>();
            MapUtil.adds(stmtMaps, "bal", balMap);
            MapUtil.puts(balMap, "tp/cdOrPrtry/cd", BalanceTypeCode.FWAV.value());
            Field65 field65 = (Field65) tag65.asField();
            balMap.put("cdtDbtInd", DRCRMARK_C.equals(field65.getDCMark()) ? CRDT.value() : DBIT.value());
            String mxDate = mt_to_mxDate(field65.getDate());
            MapUtil.puts(balMap, "dt/dt", mxDate);
            MapUtil.puts(balMap, "amt/ccy", field65.getCurrency());
            MapUtil.puts(balMap, "amt/value", field65.amount());
        }
    }
}
