package com.brilliance.swift.mt2mx.camt053001.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.camt053001.AbstractMt2MxCamt053001ParseField;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.List;

//附加说明
public class Camt053001Parse86Field extends AbstractMt2MxCamt053001ParseField {

    private static final String NAME_61 = "61";
    private static final String NAME_86 = "86";

    @Override
    public void parseField() throws SwiftException {
        SwiftMessage swiftMessage = context.get(AbstractMT.class).getSwiftMessage();
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        if (tags.size() > 0) {
            Tag lastTag = tags.get(tags.size() - 1);
            if (NAME_86.equals(lastTag.getName())) {
                if (tags.size() == 1 || !NAME_61.equals(tags.get(tags.size() - 2).getName())) {
                    stmtMaps.put("addtlStmtInf", lastTag.getValue().replaceAll(Mx2MtConstants.NEW_LINE, ""));
                }
            }
        }
    }
}
