package com.brilliance.swift.mt2mx.camt054001;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.mt2mx.AbstractMt2MxCreator;
import com.brilliance.swift.mt2mx.Mt2MxContextIdentifier;
import com.brilliance.swift.mt2mx.Mt2MxParseField;
import com.brilliance.swift.mt2mx.camt054001.impl.*;
import com.brilliance.swift.util.MapUtil;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.mt.AbstractMT;
import com.prowidesoftware.swift.model.mx.dic.CreditDebitCode;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Mt2MxCamt054001Creator extends AbstractMt2MxCreator {

    @Override
    public void preProcess() {
        super.preProcess();
        //将报文类型放入jsonMaps集合中，这个maps集合是最上层
        jsonMaps.put("identifier", "camt.054.001.08");
        MapUtil.puts(jsonMaps, "appHdr/msgDefIdr", "camt.054.001.08");
        MapUtil.puts(jsonMaps, "bkToCstmrDbtCdtNtfctn/grpHdr/creDtTm", getCreateDateStr());
        MapUtil.puts(jsonMaps, "bkToCstmrDbtCdtNtfctn/grpHdr/nbOfTxs", "1");
        Map<String, Object> ntfctnMaps = new HashMap<String, Object>();
        MapUtil.adds(jsonMaps, "bkToCstmrDbtCdtNtfctn/ntfctn", ntfctnMaps);
        Map<String, Object> ntryMaps = new HashMap<String, Object>();
        MapUtil.adds(ntfctnMaps, "ntry", ntryMaps);
        Map<String, Object> ntryDtlsMaps = new HashMap<String, Object>();
        MapUtil.adds(ntryMaps, "ntryDtls", ntryDtlsMaps);
        Map<String, Object> txDtlsMaps = new HashMap<String, Object>();
        MapUtil.adds(ntryDtlsMaps, "txDtls", txDtlsMaps);
        MapUtil.puts(ntryMaps, "sts/cd", "BOOK");
        MapUtil.puts(ntryMaps, "bkTxCd/prtry/cd", Mx2MtConstants.MT_TO_MX_DEFAULT_VALUE);
        MapUtil.puts(ntryMaps, "bkTxCd/prtry/issr", Mx2MtConstants.MT_TO_MX_DEFAULT_VALUE);
        MapUtil.puts(ntryMaps, "ntryRef", Mx2MtConstants.MT_TO_MX_DEFAULT_VALUE);
        AbstractMT abstractMT = context.get(AbstractMT.class);
        if("900".equals(abstractMT.getMessageType())){
            ntryMaps.put("cdtDbtInd", CreditDebitCode.DBIT.value());
            txDtlsMaps.put("cdtDbtInd",CreditDebitCode.DBIT.value());
        } else if("910".equals(abstractMT.getMessageType())){
            ntryMaps.put("cdtDbtInd", CreditDebitCode.CRDT.value());
            txDtlsMaps.put("cdtDbtInd",CreditDebitCode.CRDT.value());
        }
        String uetr = abstractMT.getSwiftMessage().getUETR();
        if (StringUtil.isNotEmpty(uetr)) {
            MapUtil.puts(txDtlsMaps, "refs/uetr", uetr);
        }
        context.set(Mt2MxContextIdentifier.MT_TO_MX_FLAG_50,"false");
    }

    @Override
    public List<Mt2MxParseField> getParseFieldList() {
        List<Mt2MxParseField> list = new ArrayList<Mt2MxParseField>();
        list.add(new Camt054001Parse13DField());
        list.add(new Camt054001Parse20Field());
        list.add(new Camt054001Parse21Field());
        list.add(new Camt054001Parse25Field());
        list.add(new Camt054001Parse32AField());
        list.add(new Camt054001Parse50Field());
        list.add(new Camt054001Parse52For900Field());
        list.add(new Camt054001Parse52For910Field());
        list.add(new Camt054001Parse56Field());
        list.add(new Camt054001Parse72Field());
        return list;
    }
}
