package com.brilliance.swift.mt2mx.camt054001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.camt054001.AbstractMt2MxCamt054001ParseField;
import com.brilliance.swift.util.DateUtil;
import com.brilliance.swift.util.MapUtil;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field32A;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.text.ParseException;
import java.util.Date;
//这个域存储的是起息日，货币和金额
public class Camt054001Parse32AField extends AbstractMt2MxCamt054001ParseField {

    private static final String NAME = "32A";

    @Override
    public void parseField() throws SwiftException {
        try {
            AbstractMT abstractMT = context.get(AbstractMT.class);
            Tag tag32A = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME);
            if (tag32A != null) {
                Field32A field32A = (Field32A)tag32A.asField();
                if(field32A.getValue().length()>10){
                    MapUtil.puts(ntfctnMaps, "acct/ccy", field32A.getValue().substring(6,9));
                }
                Date date = DateUtil.parseDate("20"+field32A.getDate(), "yyyyMMdd");
                String dateStr = DateUtil.format(date, "yyyy-MM-dd");
                MapUtil.puts(ntryMaps, "valDt/dt", dateStr);
                MapUtil.puts(txDtlsMaps, "rltdDts/intrBkSttlmDt", dateStr);
                MapUtil.puts(ntryMaps, "amt/value", field32A.amount());
                MapUtil.puts(ntryMaps, "amt/ccy", field32A.getCurrency());
                MapUtil.puts(txDtlsMaps, "amt/value", field32A.amount());
                MapUtil.puts(txDtlsMaps, "amt/ccy", field32A.getCurrency());
            }
        } catch (ParseException e) {
            throw  new SwiftException(e.getMessage());
        }
    }
}
