package com.brilliance.swift.mt2mx.camt054001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.camt054001.AbstractMt2MxCamt054001ParseField;
import com.brilliance.swift.util.MapUtil;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field56A;
import com.prowidesoftware.swift.model.field.Field56D;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.Map;
//中间行信息
public class Camt054001Parse56Field extends AbstractMt2MxCamt054001ParseField {

    private static final String NAME_A = "56A";

    private static final String NAME_D = "56D";

    @Override
    public void parseField() throws SwiftException {
        Field56A field56A = null;
        Field56D field56D = null;
        AbstractMT abstractMT = context.get(AbstractMT.class);
        if("900".equals(abstractMT.getMessageType())){
            return;
        }
        Tag tag = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME_A);
        if (tag != null) {
            field56A = (Field56A)tag.asField();
        }
        tag = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME_D);
        if (tag != null) {
            field56D = (Field56D)tag.asField();
        }
        Map<String, Object> rltdAgtsMaps = MapUtil.getAndCreateNotPut(txDtlsMaps, "rltdAgts");
        Map<String, Object> intrmyAgt1Maps = MapUtil.getAndCreateNotPut(rltdAgtsMaps, "intrmyAgt1");
        Map<String, Object> finInstnIdMaps = MapUtil.getAndCreateNotPut(intrmyAgt1Maps, "finInstnId");
        Map<String, Object> clrSysMmbIdMaps = MapUtil.getAndCreateNotPut(finInstnIdMaps, "clrSysMmbId");
        String account = "";
        if(field56A!=null){
            String bicCode = field56A.getBIC();
            if (StringUtil.isNotEmpty(field56A.getComponent1())) {
                account = "/" + field56A.getComponent1();
            }
            if (StringUtil.isNotEmpty(field56A.getComponent2())) {
                account = "/" + field56A.getComponent2();
            }
            if (StringUtil.isNotEmpty(account)) {
                if (account.startsWith("//") && !account.startsWith("//CH")&& !account.startsWith("//FW")&& !account.startsWith("//RT")) {
                    mt_to_mxClearingIdentifier(account, clrSysMmbIdMaps);
                }
            }
            if(clrSysMmbIdMaps.size()>0){
                finInstnIdMaps.put("clrSysMmbId", clrSysMmbIdMaps);
            }
            if(finInstnIdMaps.size()>0){
                intrmyAgt1Maps.put("finInstnId", finInstnIdMaps);
            }
            mt_to_mxBICFI(bicCode, intrmyAgt1Maps);
        }
        if (field56D != null) {
            if (StringUtil.isNotEmpty(field56D.getComponent1())) {
                account = "/" + field56D.getComponent1();
            }
            if (StringUtil.isNotEmpty(field56D.getComponent2())) {
                account = "/" + field56D.getComponent2();
            }
            if (StringUtil.isNotEmpty(account)) {
                if (account.startsWith("//") && !account.startsWith("//CH")) {
                    mt_to_mxClearingIdentifier(account, clrSysMmbIdMaps);
                }
            }
            if(clrSysMmbIdMaps.size()>0){
                finInstnIdMaps.put("clrSysMmbId", clrSysMmbIdMaps);
            }
            if(finInstnIdMaps.size()>0){
                intrmyAgt1Maps.put("finInstnId", finInstnIdMaps);
            }
            String nameAddress = field56D.getNameAndAddress();
            mt_to_mxFinancialInstitutionNameAndUnstructuredAddress(nameAddress, intrmyAgt1Maps);
        }
        if(intrmyAgt1Maps.size()>0){
            rltdAgtsMaps.put("intrmyAgt1",intrmyAgt1Maps);
        }
        if(rltdAgtsMaps.size()>0){
            txDtlsMaps.put("rltdAgts",rltdAgtsMaps);
        }
    }
}
