package com.brilliance.swift.mt2mx.camt056001;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.mt2mx.AbstractMt2MxCreator;
import com.brilliance.swift.mt2mx.Mt2MxContextIdentifier;
import com.brilliance.swift.mt2mx.Mt2MxParseField;
import com.brilliance.swift.mt2mx.camt056001.impl.*;
import com.brilliance.swift.util.MapUtil;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Mt2MxCamt056001Creator extends AbstractMt2MxCreator {

    @Override
    public void preProcess() {
        super.preProcess();
        jsonMaps.put("identifier", "camt.056.001.08");
        MapUtil.puts(jsonMaps, "appHdr/msgDefIdr", "camt.056.001.08");
        Map<String, Object> txInfMaps = new HashMap<String, Object>();
        Map<String, Object> undrlygMaps = MapUtil.adds("txInf", txInfMaps);
        MapUtil.adds(jsonMaps, "fiToFIPmtCxlReq/undrlyg", undrlygMaps);
        //Default Values
        MapUtil.puts(jsonMaps, "fiToFIPmtCxlReq/assgnmt/creDtTm", getCreateDateStr());
        MapUtil.puts(txInfMaps, "_case/cretr/agt/finInstnId/nm", Mx2MtConstants.MT_TO_MX_DEFAULT_VALUE);
        MapUtil.adds(txInfMaps, "_case/cretr/agt/finInstnId/pstlAdr/adrLine", Mx2MtConstants.MT_TO_MX_DEFAULT_VALUE);
        txInfMaps.put("orgnlEndToEndId", Mx2MtConstants.MT_TO_MX_DEFAULT_VALUE);
        //TR002
        String sendBic = (String) context.get(Mt2MxContextIdentifier.MT_SEND_BIC, true);
        if (StringUtil.isNotEmpty(sendBic)) {
            MapUtil.puts(jsonMaps, "fiToFIPmtCxlReq/assgnmt/assgnr/agt/finInstnId/bicfi", sendBic);
        }
        String receiverBic = (String) context.get(Mt2MxContextIdentifier.MT_RECEIVE_BIC, true);
        if (StringUtil.isNotEmpty(receiverBic)) {
            MapUtil.puts(jsonMaps, "fiToFIPmtCxlReq/assgnmt/assgne/agt/finInstnId/bicfi", receiverBic);
        }
        AbstractMT abstractMT = context.get(AbstractMT.class);
        String mtUETR = abstractMT.getSwiftMessage().getUETR();
        if (StringUtil.isNotEmpty(mtUETR)) {
            txInfMaps.put("orgnlUETR", mtUETR);
        }
    }

    @Override
    public List<Mt2MxParseField> getParseFieldList() {
        List<Mt2MxParseField> list = new ArrayList<Mt2MxParseField>();
        list.add(new Camt056001Parse20Field());
        list.add(new Camt056001Parse21Field());
        list.add(new Camt056001Parse11SField());
        list.add(new Camt056001Parse79Field());
        list.add(new Camt056001Parse32AField());
        return list;
    }
}
