package com.brilliance.swift.mt2mx.camt056001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.camt056001.AbstractMt2MxCamt056001ParseField;
import com.brilliance.swift.util.MapUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field11S;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

//这个域的作用就是将原始消息的名称和原始消息的创建时间存入map集合
public class Camt056001Parse11SField extends AbstractMt2MxCamt056001ParseField {

    private static final String NAME = "11S";

    @Override
    public void parseField() throws SwiftException {
        SwiftMessage swiftMessage = context.get(AbstractMT.class).getSwiftMessage();
        Tag tag11S = swiftMessage.getBlock4().getTagByName(NAME);
        if (tag11S != null) {
            Field11S field11S = (Field11S) tag11S.asField();
            String mtType = field11S.getMT();
            Pattern r = Pattern.compile("[1,2]0[0-9]");
            Matcher m = r.matcher(mtType);
            if(!m.matches()){
                buildSTErrorInfo(122,"Block4:11S:",mtType);
                return;
            }
            //TR003
            MapUtil.puts(txInfMaps, "orgnlGrpInf/orgnlMsgNmId", getMxType(field11S.getMT()));
            //TR001
            String mxDate = mt_to_mxDate(field11S.getDate()) + "T00:00:00+00:00";
            MapUtil.puts(txInfMaps, "orgnlGrpInf/orgnlCreDtTm", mxDate);
        }
    }
}
