package com.brilliance.swift.mt2mx.camt056001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.camt056001.AbstractMt2MxCamt056001ParseField;
import com.brilliance.swift.util.MapUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field32A;
import com.prowidesoftware.swift.model.mt.AbstractMT;

//这个域的作用是将原始发报行给收报行的金额和原始结算日期填入map集合中
public class Camt056001Parse32AField extends AbstractMt2MxCamt056001ParseField {

    private static final String NAME = "32A";

    @Override
    public void parseField() throws SwiftException {
        SwiftMessage swiftMessage = context.get(AbstractMT.class).getSwiftMessage();
        Tag tag32A = swiftMessage.getBlock4().getTagByName(NAME);
        if (tag32A == null) {
            //Translation Preconditions
            buildSTErrorInfo(77, "Block4:32A:", null);
        } else {
            Field32A field32A = (Field32A) tag32A.asField();
            txInfMaps.put("orgnlIntrBkSttlmDt", mt_to_mxDate(field32A.getDate()));
            MapUtil.puts(txInfMaps, "orgnlIntrBkSttlmAmt/value", field32A.amount());
            MapUtil.puts(txInfMaps, "orgnlIntrBkSttlmAmt/ccy", field32A.getCurrency());
        }
    }
}
