package com.brilliance.swift.mt2mx.camt057001;

import com.brilliance.swift.mt2mx.AbstractMt2MxCreator;
import com.brilliance.swift.mt2mx.Mt2MxParseField;
import com.brilliance.swift.mt2mx.camt057001.impl.*;
import com.brilliance.swift.util.MapUtil;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Mt2MxCamt057001Creator extends AbstractMt2MxCreator {

    @Override
    public void preProcess() {
        super.preProcess();
        jsonMaps.put("identifier", "camt.057.001.06");
        MapUtil.puts(jsonMaps, "appHdr/msgDefIdr", "camt.057.001.06");
        MapUtil.puts(jsonMaps, "ntfctnToRcv/grpHdr/creDtTm", getCreateDateStr());
        MapUtil.puts(jsonMaps, "ntfctnToRcv/grpHdr/nbOfTxs", "1");
        Map<String, Object> itmMaps = new HashMap<String, Object>();
        MapUtil.adds(jsonMaps, "ntfctnToRcv/ntfctn/itm", itmMaps);
        AbstractMT abstractMT = context.get(AbstractMT.class);
        String uetr = abstractMT.getSwiftMessage().getUETR();
        if (StringUtil.isNotEmpty(uetr)) {
            itmMaps.put("uetr",uetr);
        }

    }

    @Override
    public List<Mt2MxParseField> getParseFieldList() {
        List<Mt2MxParseField> list = new ArrayList<Mt2MxParseField>();
        list.add(new Camt057001Parse20Field());
        list.add(new Camt057001Parse21Field());
        list.add(new Camt057001Parse25Field());
        list.add(new Camt057001Parse30Field());
        list.add(new Camt057001Parse32BField());
        list.add(new Camt057001Parse50Field());
        list.add(new Camt057001Parse52Field());
        list.add(new Camt057001Parse56Field());
        return list;
    }
}
