package com.brilliance.swift.mt2mx.camt057001.impl;

import com.alibaba.fastjson.JSONArray;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.camt057001.AbstractMt2MxCamt057001ParseField;
import com.brilliance.swift.util.MapUtil;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field32B;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.Map;
//货币和金额
public class Camt057001Parse32BField extends AbstractMt2MxCamt057001ParseField {

    private static final String NAME = "32B";

    @Override
    public void parseField() throws SwiftException {
        AbstractMT abstractMT = context.get(AbstractMT.class);
        Tag tag32B = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME);
        if (tag32B != null) {
            Field32B field32B = (Field32B) tag32B.asField();
            JSONArray itmJsonArray = (JSONArray) ntfctnMaps.get("itm");
            Map<String, Object> itmMaps = (Map<String, Object>)itmJsonArray.get(0);
            MapUtil.puts(itmMaps, "amt/value", field32B.amount());
            MapUtil.puts(itmMaps, "amt/ccy", field32B.getCurrency());
        }
    }
}
