package com.brilliance.swift.mt2mx.camt060001;

import com.alibaba.fastjson.JSONArray;
import com.brilliance.swift.mt2mx.AbstractMt2MxCreator;
import com.brilliance.swift.mt2mx.Mt2MxParseField;
import com.brilliance.swift.mt2mx.camt060001.impl.Camt060001Parse12Field;
import com.brilliance.swift.mt2mx.camt060001.impl.Camt060001Parse20Field;
import com.brilliance.swift.mt2mx.camt060001.impl.Camt060001Parse25Field;
import com.brilliance.swift.mt2mx.camt060001.impl.Camt060001Parse34FField;
import com.brilliance.swift.util.MapUtil;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.ArrayList;
import java.util.List;

public class Mt2MxCamt060001Creator extends AbstractMt2MxCreator {

    @Override
    public void preProcess() {
        super.preProcess();
        jsonMaps.put("identifier", "camt.060.001.05");
        MapUtil.puts(jsonMaps, "appHdr/msgDefIdr", "camt.060.001.05");
        MapUtil.puts(jsonMaps, "acctRptgReq/grpHdr/creDtTm", getCreateDateStr());
        MapUtil.puts(jsonMaps, "acctRptgReq/rptgReq", new JSONArray());
    }

    @Override
    public List<Mt2MxParseField> getParseFieldList() {
        List<Mt2MxParseField> list = new ArrayList<Mt2MxParseField>();
        list.add(new Camt060001Parse20Field());
        AbstractMT abstractMT = context.get(AbstractMT.class);
        Tag[] tags = abstractMT.getSwiftMessage().getBlock4().getTagsByName("12");
        if (tags != null && tags.length > 0) {
            for (int i = 0; i < tags.length; i++) {
                list.add(new Camt060001Parse12Field(i));
                list.add(new Camt060001Parse25Field(i));
                list.add(new Camt060001Parse34FField(i));
            }
        }
        return list;
    }
}
