package com.brilliance.swift.mt2mx.pacs002001.mt103rejt;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.mt2mx.pacs002001.AbstractMt2MxPacs002001ParseField;
import com.brilliance.swift.util.MapUtil;
import com.brilliance.swift.util.StringUtil;
import com.brilliance.swift.vo.common.PaymentTransactionStatusCode;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field72;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.List;

public class Pacs002001Parse72Field extends AbstractMt2MxPacs002001ParseField {
    private static final String NAME = "72";

    @Override
    public void parseField() {
        AbstractMT abstractMT = context.get(AbstractMT.class);
        Tag tag72 = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME);
        if (tag72 != null) {
            String instdID = Mx2MtConstants.MT_TO_MX_DEFAULT_VALUE;
            String orgnlEndToEndId = Mx2MtConstants.MT_TO_MX_DEFAULT_VALUE;
            List<String> lines = ((Field72) tag72.asField()).getLines();
            for (String line : lines) {
                if (line.startsWith("/MREF/") && Mx2MtConstants.MT_TO_MX_DEFAULT_VALUE.equals(instdID)) {
                    instdID = line.substring(6);
                } else if (line.startsWith("/TREF/") && Mx2MtConstants.MT_TO_MX_DEFAULT_VALUE.equals(orgnlEndToEndId)) {
                    orgnlEndToEndId = line.substring(6);
                }
            }
            txInfAndStsMaps.put("orgnlInstrId", instdID);
            if ("103".equals(abstractMT.getMessageType())) {
                txInfAndStsMaps.put("orgnlEndToEndId", orgnlEndToEndId);
            }
            MapUtil.puts(txInfAndStsMaps, "orgnlGrpInf/orgnlMsgId", instdID);
            txInfAndStsMaps.put("txSts", PaymentTransactionStatusCode.RJCT.value());
            String mt72 = StringUtil.joinString(lines.toArray(new String[0]), Mx2MtConstants.NEW_LINE);
            mt_to_mxReject72(mt72, txInfAndStsMaps);
        }
    }
}
