package com.brilliance.swift.mt2mx.pacs004001.mt103retn;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.pacs004001.AbstractMt2MxPacs004001ParseField;
import com.brilliance.swift.util.MapUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field13C;
import com.prowidesoftware.swift.model.mt.AbstractMT;

public class Pacs004001Parse13CField extends AbstractMt2MxPacs004001ParseField {

    private static final String NAME = "13C";

    @Override
    public void parseField() throws SwiftException {
        SwiftMessage swiftMessage = context.get(AbstractMT.class).getSwiftMessage();
        Tag[] tags = swiftMessage.getBlock4().getTagsByName(NAME);
        for (Tag tag13C : tags) {
            Field13C field13C = (Field13C) tag13C.asField();
            String mtTime = field13C.getTime();
            String mtOffset = field13C.getOffset();
            String mxTime = mtTime.substring(0, 2) + ":" + mtTime.substring(2, 4) + ":00" +
                    field13C.getSign() +
                    mtOffset.substring(0, 2) + ":" + mtOffset.substring(2, 4);
            mxTime = "0001-01-01T" + mxTime;
            if ("SNDTIME".equals(field13C.getCode())) {
                MapUtil.puts(txInfMaps, "sttlmTmIndctn/dbtDtTm", mxTime);
            } else if ("RNCTIME".equals(field13C.getCode())) {
                MapUtil.puts(txInfMaps, "sttlmTmIndctn/cdtDtTm", mxTime);
            }
        }
    }
}
