package com.brilliance.swift.mt2mx.pacs004001.mt103retn;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.pacs004001.AbstractMt2MxPacs004001ParseField;
import com.brilliance.swift.util.MapUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field32A;
import com.prowidesoftware.swift.model.mt.AbstractMT;

public class Pacs004001Parse32AField extends AbstractMt2MxPacs004001ParseField {

    private static final String NAME = "32A";

    @Override
    public void parseField() throws SwiftException {
        SwiftMessage swiftMessage = context.get(AbstractMT.class).getSwiftMessage();
        Tag tag32A = swiftMessage.getBlock4().getTagByName(NAME);
        if (tag32A != null) {
            Field32A field32A = (Field32A) tag32A.asField();
            String mxDate = mt_to_mxDate(field32A.getDate());
            txInfMaps.put("intrBkSttlmDt", mxDate);
            MapUtil.puts(txInfMaps, "rtrdIntrBkSttlmAmt/value", field32A.amount());
            MapUtil.puts(txInfMaps, "rtrdIntrBkSttlmAmt/ccy", field32A.getCurrency());
        }
    }
}
