package com.brilliance.swift.mt2mx.pacs004001.mt103retn;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.pacs004001.AbstractMt2MxPacs004001ParseField;
import com.brilliance.swift.util.MapUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field33B;
import com.prowidesoftware.swift.model.mt.AbstractMT;

public class Pacs004001Parse33BField extends AbstractMt2MxPacs004001ParseField {

    private static final String NAME = "33B";

    @Override
    public void parseField() throws SwiftException {
        SwiftMessage swiftMessage = context.get(AbstractMT.class).getSwiftMessage();
        Tag tag33B = swiftMessage.getBlock4().getTagByName(NAME);
        if (tag33B != null) {
            Field33B field33B = (Field33B) tag33B.asField();
            MapUtil.puts(txInfMaps, "rtrdInstdAmt/value", field33B.amount());
            MapUtil.puts(txInfMaps, "rtrdInstdAmt/ccy", field33B.getCurrency());
        }
    }
}
