package com.brilliance.swift.mt2mx.pacs004001.mt103retn;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.pacs004001.AbstractMt2MxPacs004001ParseField;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field36;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.math.BigDecimal;

public class Pacs004001Parse36Field extends AbstractMt2MxPacs004001ParseField {

    private static final String NAME = "36";

    @Override
    public void parseField() throws SwiftException {
        SwiftMessage swiftMessage = context.get(AbstractMT.class).getSwiftMessage();
        Tag tag36 = swiftMessage.getBlock4().getTagByName(NAME);
        if (tag36 != null) {
            Field36 field36 = (Field36) tag36.asField();
            txInfMaps.put("xchgRate", new BigDecimal(field36.getRateAsNumber().toString()).stripTrailingZeros().toPlainString());
        }
    }
}
