package com.brilliance.swift.mt2mx.pacs004001.mt103retn;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.pacs004001.AbstractMt2MxPacs004001ParseField;
import com.brilliance.swift.util.MapUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field52A;
import com.prowidesoftware.swift.model.field.Field52D;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.HashMap;
import java.util.Map;

public class Pacs004001Parse52Field extends AbstractMt2MxPacs004001ParseField {

    private static final String NAME_A = "52A";

    private static final String NAME_D = "52D";

    @Override
    public void parseField() throws SwiftException {
        SwiftMessage swiftMessage = context.get(AbstractMT.class).getSwiftMessage();
        Tag tag52A = swiftMessage.getBlock4().getTagByName(NAME_A);
        Tag tag52D = swiftMessage.getBlock4().getTagByName(NAME_D);
        if (tag52A != null) {
            Field52A field52A = (Field52A) tag52A.asField();
            MapUtil.puts(txInfMaps, "rtrChain/dbtrAgt/finInstnId/bicfi", field52A.getBIC());
            String ptyId = field52A.getComponent1() == null ? field52A.getComponent2() : null;
            if (ptyId != null && ptyId.startsWith("/") && !ptyId.startsWith("/CH") && !ptyId.startsWith("/FW")) {
                Map<String, Object> clrSysMmbIdMap = new HashMap<String, Object>();
                mt_to_mxClearingIdentifier("/" + ptyId, clrSysMmbIdMap);
                MapUtil.puts(txInfMaps, "rtrChain/dbtrAgt/finInstnId/clrSysMmbId", clrSysMmbIdMap);
            }
        }
        if (tag52D != null) {
            Field52D field52D = (Field52D) tag52D.asField();
            Map<String, Object> dbtrAgtMap = new HashMap<String, Object>();
            mt_to_mxFinancialInstitutionNameAndUnstructuredAddress(field52D.getNameAndAddress(), dbtrAgtMap);
            MapUtil.puts(txInfMaps, "rtrChain/dbtrAgt", dbtrAgtMap);
            String ptyId = field52D.getComponent1() == null ? field52D.getComponent2() : null;
            if (ptyId != null && ptyId.startsWith("/") && !ptyId.startsWith("/CH")) {
                Map<String, Object> clrSysMmbIdMap = new HashMap<String, Object>();
                mt_to_mxClearingIdentifier("/" + ptyId, clrSysMmbIdMap);
                MapUtil.puts(txInfMaps, "rtrChain/dbtrAgt/finInstnId/clrSysMmbId", clrSysMmbIdMap);
            }
        }
    }
}
