package com.brilliance.swift.mt2mx.pacs004001.mt103retn;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.pacs004001.AbstractMt2MxPacs004001ParseField;
import com.brilliance.swift.util.MapUtil;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field59;
import com.prowidesoftware.swift.model.field.Field59A;
import com.prowidesoftware.swift.model.field.Field59F;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Pacs004001Parse59Field extends AbstractMt2MxPacs004001ParseField {

    private static final String NAME = "59";

    private static final String NAME_A = "59A";

    private static final String NAME_F = "59F";

    @Override
    public void parseField() throws SwiftException {
        SwiftMessage swiftMessage = context.get(AbstractMT.class).getSwiftMessage();
        Tag tag59 = swiftMessage.getBlock4().getTagByName(NAME);
        Tag tag59A = swiftMessage.getBlock4().getTagByName(NAME_A);
        Tag tag59F = swiftMessage.getBlock4().getTagByName(NAME_F);

        if (tag59 != null) {
            Field59 field59 = (Field59) tag59.asField();
            String component1 = field59.getComponent1();
            String nameAndAddressLine1 = field59.getNameAndAddressLine1();
            if (Mx2MtConstants.MX_TO_MT_DEFAULT_VALUE.equals(component1) && nameAndAddressLine1.startsWith("//")) {
                if (isMTClearingSystemCodeInList(nameAndAddressLine1)) {
                    Map<String, Object> clrSysMmbIdMap = new HashMap<String, Object>();
                    mt_to_mxClearingIdentifier(nameAndAddressLine1, clrSysMmbIdMap);
                    MapUtil.puts(txInfMaps, "rtrChain/cdtr/agt/finInstnId/clrSysMmbId", clrSysMmbIdMap);
                } else {
                    Map<String, Object> finInstnIdMap = new HashMap<String, Object>();
                    mt_to_mxClearingSystemToNameAndAddressLine(field59.getNameAndAddress(), null, finInstnIdMap, "Cdtr/Agt/FinInstnId");
                    MapUtil.puts(txInfMaps, "rtrChain/cdtr/agt/finInstnId", finInstnIdMap);
                    buildSTErrorInfo(102, "PmtRtr/TxInf/RtrChain/Cdtr/Agt/FinInstnId", null);
                }
            } else {
                Map<String, Object> othrMap = MapUtil.puts("id", Mx2MtConstants.MT_TO_MX_DEFAULT_VALUE);
                MapUtil.adds(txInfMaps, "rtrChain/cdtr/pty/id/orgId/othr", othrMap);
                Map<String, Object> ptyMap = new HashMap<String,Object>();
                mt_to_mxPartyNameAndAddress(field59.getNameAndAddress(), ptyMap);
                MapUtil.puts(txInfMaps, "rtrChain/cdtr/pty", ptyMap);
            }
        }
        if (tag59A != null) {
            Map<String, Object> othrMap = MapUtil.puts("id", Mx2MtConstants.MT_TO_MX_DEFAULT_VALUE);
            MapUtil.adds(txInfMaps, "rtrChain/cdtr/pty/id/orgId/othr", othrMap);
            MapUtil.puts(txInfMaps, "rtrChain/cdtr/pty/id/orgId/anyBIC", ((Field59A) tag59A.asField()).getBIC());
        }
        if (tag59F != null) {
            Map<String, Object> othrMap = MapUtil.puts("id", Mx2MtConstants.MT_TO_MX_DEFAULT_VALUE);
            MapUtil.adds(txInfMaps, "rtrChain/cdtr/pty/id/orgId/othr", othrMap);
            Field59F field59F = (Field59F) tag59F.asField();
            List<String> lines = field59F.getLines();
            if (StringUtil.isNotEmpty(field59F.getComponent1())) {
                lines.remove(0);
            }
            Map<String, Object> ptyMap = new HashMap<String, Object>();
            mt_to_mxPartyNameAndStructuredAddress(StringUtil.joinString(lines.toArray(new String[0]), Mx2MtConstants.NEW_LINE), ptyMap);
            MapUtil.puts(txInfMaps, "rtrChain/cdtr/pty", ptyMap);
        }
    }
}
