package com.brilliance.swift.mt2mx.pacs004001.mt103retn;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.pacs004001.AbstractMt2MxPacs004001ParseField;
import com.brilliance.swift.util.MapUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.HashMap;
import java.util.Map;

public class Pacs004001Parse70Field extends AbstractMt2MxPacs004001ParseField {

    private static final String NAME = "70";

    @Override
    public void parseField() throws SwiftException {
        SwiftMessage swiftMessage = context.get(AbstractMT.class).getSwiftMessage();
        Tag tag70 = swiftMessage.getBlock4().getTagByName(NAME);
        if (tag70 != null) {
            Map<String, Object> ultmtCdtrPtyMap = new HashMap<String, Object>();
            Map<String, Object> ultmtDbtrPtyMap = new HashMap<String, Object>();
            mt_to_mxUltimateParty(tag70.getValue(), "/ULTB/", ultmtCdtrPtyMap);
            MapUtil.puts(txInfMaps, "rtrChain/ultmtCdtr/pty", ultmtCdtrPtyMap);
            mt_to_mxUltimateParty(tag70.getValue(), "/ULTD/", ultmtDbtrPtyMap);
            MapUtil.puts(txInfMaps, "rtrChain/ultmtDbtr/pty", ultmtDbtrPtyMap);
        }
    }
}
