package com.brilliance.swift.mt2mx.pacs004001.mt103retn;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.Mt2MxContextIdentifier;
import com.brilliance.swift.mt2mx.pacs004001.AbstractMt2MxPacs004001ParseField;
import com.brilliance.swift.util.MapUtil;
import com.brilliance.swift.util.SwiftTransferUtil;
import com.brilliance.swift.vo.common.ChargeForEnum;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field71F;
import com.prowidesoftware.swift.model.field.Field71G;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.HashMap;
import java.util.Map;

public class Pacs004001Parse71Field extends AbstractMt2MxPacs004001ParseField {

    private static final String NAME_A = "71A";

    private static final String NAME_F = "71F";

    private static final String NAME_G = "71G";

    @Override
    public void parseField() throws SwiftException {
        SwiftMessage swiftMessage = context.get(AbstractMT.class).getSwiftMessage();
        Tag tag71A = swiftMessage.getBlock4().getTagByName(NAME_A);
        Tag[] tags71F = swiftMessage.getBlock4().getTagsByName(NAME_F);
        Tag tag71G = swiftMessage.getBlock4().getTagByName(NAME_G);
        if (tag71A != null) {
            ChargeForEnum chargeForEnum = SwiftTransferUtil.getChargeForByDesc(tag71A.getValue());
            if (chargeForEnum != null) {
                if (ChargeForEnum.DEBT.equals(chargeForEnum)) {
                    chargeForEnum = ChargeForEnum.SHAR;
                }
                txInfMaps.put("chrgBr", chargeForEnum.value());
            }
        }
        if (tags71F != null) {
            for (Tag tag71F : tags71F) {
                Field71F field71F = (Field71F) tag71F.asField();
                Map<String, Object> chrgsInfMap = new HashMap<String, Object>();
                MapUtil.adds(txInfMaps, "chrgsInf", chrgsInfMap);
                MapUtil.puts(chrgsInfMap, "amt/ccy", field71F.getCurrency());
                MapUtil.puts(chrgsInfMap, "amt/value", field71F.amount());
                MapUtil.puts(chrgsInfMap, "agt/finInstnId/nm", Mx2MtConstants.MT_TO_MX_DEFAULT_VALUE);
                MapUtil.adds(chrgsInfMap, "agt/finInstnId/pstlAdr/adrLine", Mx2MtConstants.MT_TO_MX_DEFAULT_VALUE);
            }
        }
        if (tag71G != null) {
            Field71G field71G = (Field71G) tag71G.asField();
            Map<String, Object> chrgsInfMap = new HashMap<String, Object>();
            MapUtil.adds(txInfMaps, "chrgsInf", chrgsInfMap);
            MapUtil.puts(chrgsInfMap, "amt/ccy", field71G.getCurrency());
            MapUtil.puts(chrgsInfMap, "amt/value", field71G.amount());
            MapUtil.puts(chrgsInfMap, "agt/finInstnId/bicfi", context.get(Mt2MxContextIdentifier.MT_RECEIVE_BIC, true));
        }
    }
}
