package com.brilliance.swift.mt2mx.pacs004001.mt103retn;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.pacs004001.AbstractMt2MxPacs004001ParseField;
import com.brilliance.swift.util.MapUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class Pacs004001Parse77BField extends AbstractMt2MxPacs004001ParseField {

    private static final String NAME = "77B";

    @Override
    public void parseField() throws SwiftException {
        SwiftMessage swiftMessage = context.get(AbstractMT.class).getSwiftMessage();
        Tag tag77B = swiftMessage.getBlock4().getTagByName(NAME);
        if (tag77B != null) {
            Matcher cdtrCtryOfResMatcher = Pattern.compile("/BENEFRES/([A-Z]{2})").matcher(tag77B.getValue());
            Matcher dbtrCtryOfResMatcher = Pattern.compile("/ORDERRES/([A-Z]{2})").matcher(tag77B.getValue());
            if (cdtrCtryOfResMatcher.find()) {
                MapUtil.puts(txInfMaps, "rtrChain/cdtr/pty/ctryOfRes", cdtrCtryOfResMatcher.group(1));
            }
            if (dbtrCtryOfResMatcher.find()) {
                MapUtil.puts(txInfMaps, "rtrChain/dbtr/pty/ctryOfRes", dbtrCtryOfResMatcher.group(1));
            }
        }
    }
}
