package com.brilliance.swift.mt2mx.pacs004001.mt202retn;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.pacs004001.AbstractMt2MxPacs004001ParseField;
import com.brilliance.swift.util.MapUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field58A;
import com.prowidesoftware.swift.model.field.Field58D;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.HashMap;
import java.util.Map;

public class Pacs004001Parse58Field extends AbstractMt2MxPacs004001ParseField {

    private static final String NAME_A = "58A";

    private static final String NAME_D = "58D";

    @Override
    public void parseField() throws SwiftException {
        SwiftMessage swiftMessage = context.get(AbstractMT.class).getSwiftMessage();
        Tag tag58A = swiftMessage.getBlock4().getTagByName(NAME_A);
        Tag tag58D = swiftMessage.getBlock4().getTagByName(NAME_D);
        if (tag58A != null) {
            Field58A field58A = (Field58A) tag58A.asField();
            String ptyId = field58A.getComponent1() == null ? field58A.getComponent2() : null;
            if (ptyId != null && ptyId.startsWith("/") && !ptyId.startsWith("/CH") && !ptyId.startsWith("/FW") && !ptyId.startsWith("/RT")) {
                Map<String, Object> clrSysMmbIdMap = new HashMap<String, Object>();
                mt_to_mxClearingIdentifier("/" + ptyId, clrSysMmbIdMap);
                MapUtil.puts(txInfMaps, "rtrChain/cdtr/agt/finInstnId/clrSysMmbId", clrSysMmbIdMap);
            }
            MapUtil.puts(txInfMaps, "rtrChain/cdtr/agt/finInstnId/bicfi", field58A.getBIC());
        }
        if (tag58D != null) {
            Field58D field58D = (Field58D) tag58D.asField();
            String ptyId = field58D.getComponent1() == null ? field58D.getComponent2() : null;
            if (ptyId != null && ptyId.startsWith("/") && !ptyId.startsWith("/CH")) {
                Map<String, Object> clrSysMmbIdMap = new HashMap<String, Object>();
                mt_to_mxClearingIdentifier("/" + ptyId, clrSysMmbIdMap);
                MapUtil.puts(txInfMaps, "rtrChain/cdtr/agt/finInstnId/clrSysMmbId", clrSysMmbIdMap);
            }
            Map<String, Object> cdtrAgtMap = new HashMap<String, Object>();
            mt_to_mxFinancialInstitutionNameAndUnstructuredAddress(field58D.getNameAndAddress(), cdtrAgtMap);
            MapUtil.puts(txInfMaps, "rtrChain/cdtr/agt", cdtrAgtMap);
        }
    }
}
