package com.brilliance.swift.mt2mx.pacs008001.impl;

import com.alibaba.fastjson.JSONArray;
import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.Mt2MxContextIdentifier;
import com.brilliance.swift.mt2mx.pacs008001.AbstractMt2MxPacs008001ParseField;
import com.brilliance.swift.util.MapUtil;
import com.brilliance.swift.util.SwiftTransferUtil;
import com.brilliance.swift.vo.common.ChargeForEnum;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field71A;
import com.prowidesoftware.swift.model.field.Field71F;
import com.prowidesoftware.swift.model.field.Field71G;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.math.BigDecimal;
import java.util.HashMap;
import java.util.Map;

public class Pacs00801Parse71Field extends AbstractMt2MxPacs008001ParseField {

    private static final String NAME_A = "71A";

    private static final String NAME_F = "71F";

    private static final String NAME_G = "71G";

    @Override
    public void parseField() throws SwiftException {
        Field71A field71A = null;
        Field71G field71G = null;
        AbstractMT abstractMT = context.get(AbstractMT.class);
        Tag tag = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME_A);
        if (tag != null) {
            field71A = (Field71A)tag.asField();
        }
        tag = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME_G);
        if (tag != null) {
            field71G = (Field71G)tag.asField();
        }
        if (field71A != null) {
            ChargeForEnum chargeForEnum = SwiftTransferUtil.getChargeForByDesc(field71A.getValue());
            if (chargeForEnum != null) {
                cdtTrfTxInfMaps.put("chrgBr", chargeForEnum.value());
            }
        }
        Tag[] tags = abstractMT.getSwiftMessage().getBlock4().getTagsByName(NAME_F);
        if (tags != null && tags.length > 0) {
            JSONArray jsonArray = new JSONArray();
            cdtTrfTxInfMaps.put("chrgsInf", jsonArray);
            for (int i=0; i<tags.length; i++) {
                Field71F field71F = (Field71F)tags[i].asField();
                String ccy = field71F.getCurrency();
                BigDecimal amt = field71F.amount();
                Map<String, Object> chrgsInfMaps = new HashMap<String, Object>();
                MapUtil.adds(cdtTrfTxInfMaps, "chrgsInf", chrgsInfMaps);
                MapUtil.puts(chrgsInfMaps, "amt/value", amt);
                MapUtil.puts(chrgsInfMaps, "amt/ccy", ccy);
                MapUtil.puts(chrgsInfMaps, "agt/finInstnId/nm", Mx2MtConstants.MX_TO_MT_DEFAULT_VALUE);
                MapUtil.adds(chrgsInfMaps, "agt/finInstnId/pstlAdr/adrLine", Mx2MtConstants.MX_TO_MT_DEFAULT_VALUE);
            }
        }
        if (field71G != null) {
            String ccy = field71G.getCurrency();
            BigDecimal amt = field71G.amount();
            Map<String, Object> chrgsInfMaps = new HashMap<String, Object>();
            MapUtil.adds(cdtTrfTxInfMaps, "chrgsInf", chrgsInfMaps);
            MapUtil.puts(chrgsInfMaps, "amt/value", amt);
            MapUtil.puts(chrgsInfMaps, "amt/ccy", ccy);
            String receiverBic = (String) context.get(Mt2MxContextIdentifier.MT_RECEIVE_BIC, true);
            MapUtil.puts(chrgsInfMaps, "agt/finInstnId/bicfi", receiverBic);
        }
    }
}
