package com.brilliance.swift.mt2mx.pacs009001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.pacs009001.AbstractMt2MxPacs009001ParseField;
import com.brilliance.swift.util.MapUtil;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field13C;
import com.prowidesoftware.swift.model.mt.AbstractMT;

public class Pacs009001Parse13CField extends AbstractMt2MxPacs009001ParseField {

    private static final String NAME = "13C";

    @Override
    public void parseField() throws SwiftException {
        AbstractMT abstractMT = context.get(AbstractMT.class);
        Tag[] tags = abstractMT.getSwiftMessage().getBlock4().getTagsByName(NAME);
        if (tags != null && tags.length > 0) {
            for (int i=0; i<tags.length; i++) {
                Field13C field13C = (Field13C)tags[i].asField();
                String dateTimeStr = "0001-01-01T"
                        + field13C.getTime().substring(0,2)
                        + ":" + field13C.getTime().substring(2,4)
                        + ":00"
                        + field13C.getSign()
                        + field13C.getOffset().substring(0, 2)
                        + ":" + field13C.getOffset().substring(2, 4);
                String timeStr = field13C.getTime().substring(0,2)
                        + ":" + field13C.getTime().substring(2,4)
                        + ":00"
                        + field13C.getSign()
                        + field13C.getOffset().substring(0, 2)
                        + ":" + field13C.getOffset().substring(2, 4);
                if ("SNDTIME".equals(field13C.getCode())) {
                    MapUtil.puts(cdtTrfTxInfMaps, "sttlmTmIndctn/dbtDtTm", dateTimeStr);
                } else if ("RNCTIME".equals(field13C.getCode())) {
                    MapUtil.puts(cdtTrfTxInfMaps, "sttlmTmIndctn/cdtDtTm", dateTimeStr);
                } else if ("CLSTIME".equals(field13C.getCode())) {
                    MapUtil.puts(cdtTrfTxInfMaps, "sttlmTmReq/clsTm", timeStr);
                } else if ("TILTIME".equals(field13C.getCode())) {
                    MapUtil.puts(cdtTrfTxInfMaps, "sttlmTmReq/tillTm", timeStr);
                } else if ("FROTIME".equals(field13C.getCode())) {
                    MapUtil.puts(cdtTrfTxInfMaps, "sttlmTmReq/frTm", timeStr);
                } else if ("REJTIME".equals(field13C.getCode())) {
                    MapUtil.puts(cdtTrfTxInfMaps, "sttlmTmReq/rjctTm", timeStr);
                }
            }
        }
    }
}
