package com.brilliance.swift.mt2mx.pacs009001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.pacs009001.AbstractMt2MxPacs009001ParseField;
import com.brilliance.swift.util.DateUtil;
import com.brilliance.swift.util.MapUtil;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field32A;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.text.ParseException;
import java.util.Date;

public class Pacs009001Parse32AField extends AbstractMt2MxPacs009001ParseField {

    private static final String NAME = "32A";

    @Override
    public void parseField() throws SwiftException {
        try {
            AbstractMT abstractMT = context.get(AbstractMT.class);
            Tag tag = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME);
            if (tag != null) {
                Field32A field32A = (Field32A)tag.asField();
                Date date = DateUtil.parseDate("20"+field32A.getDate(), "yyyyMMdd");
                String dateStr = DateUtil.format(date, "yyyy-MM-dd");
                cdtTrfTxInfMaps.put("intrBkSttlmDt", dateStr);
                MapUtil.puts(cdtTrfTxInfMaps, "intrBkSttlmAmt/value", field32A.amount());
                MapUtil.puts(cdtTrfTxInfMaps, "intrBkSttlmAmt/ccy", field32A.getCurrency());
            }
        } catch (ParseException e) {
            throw  new SwiftException(e.getMessage());
        }
    }
}
