package com.brilliance.swift.mt2mx.pacs009001.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.pacs009001.AbstractMt2MxPacs009001ParseField;
import com.brilliance.swift.util.MapUtil;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.*;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.Map;

public class Pacs009001ParseSeqB57Field extends AbstractMt2MxPacs009001ParseField {

    private static final String NAME_A = "57A";

    private static final String NAME_B = "57B";

    private static final String NAME_C = "57C";

    private static final String NAME_D = "57D";

    private static final String SEQUENCE_B = "B";

    private static final String SEQUENCE_A = "A";

    private static final String NAME_A_58 = "58A";

    private static final String NAME_D_58 = "58D";

    @Override
    public void parseField() throws SwiftException {
        AbstractMT abstractMT = context.get(AbstractMT.class);
        if (!abstractMT.getSwiftMessage().isCOV()) {
            return;
        }
        Field57A field57A = null;
        Field57B field57B = null;
        Field57C field57C = null;
        Field57D field57D = null;
        Field58A field58A = null;
        Field58D field58D = null;
        Tag tag = getTagByName(NAME_A, SEQUENCE_B);
        if (tag != null) {
            field57A = (Field57A)tag.asField();
        }
        tag = getTagByName(NAME_B,  SEQUENCE_B);
        if (tag != null) {
            field57B = (Field57B)tag.asField();
        }
        tag = getTagByName(NAME_C,  SEQUENCE_B);
        if (tag != null) {
            field57C = (Field57C)tag.asField();
        }
        tag = getTagByName(NAME_D,  SEQUENCE_B);
        if (tag != null) {
            field57D = (Field57D)tag.asField();
        }
        Map<String, Object> cdtrAgtMaps = MapUtil.getAndCreateNotPut(undrlygCstmrCdtTrfMaps, "cdtrAgt");
        Map<String, Object> cdtrAgtAcctMaps = MapUtil.getAndCreateNotPut(undrlygCstmrCdtTrfMaps, "cdtrAgtAcct");
        String account = "";
        if(tag == null){
            tag = getTagByName(NAME_A_58,SEQUENCE_A);
            if(tag != null){
                field58A = (Field58A)tag.asField();
            }
            tag = getTagByName(NAME_D_58,SEQUENCE_A);
            if(tag != null){
                field58D = (Field58D)tag.asField();
            }
            if(field58A !=null){
                String bicCode = field58A.getBIC();
                mt_to_mxBICFI(bicCode, cdtrAgtMaps);
                if (StringUtil.isNotEmpty(field58A.getComponent1())) {
                    account += "/" + field58A.getComponent1();
                }
                if (StringUtil.isNotEmpty(field58A.getComponent2())) {
                    account += "/" + field58A.getComponent2();
                }
                if (account.startsWith("//") && !account.startsWith("//CH") && !account.startsWith("//FW") && !account.startsWith("//RT")) {
                    Map<String, Object> finInstnIdMaps = MapUtil.getAndCreateNotPut(cdtrAgtMaps, "finInstnId");
                    Map<String, Object> clrSysMmbIdMaps = MapUtil.getAndCreateNotPut(finInstnIdMaps, "clrSysMmbId");
                    mt_to_mxClearingIdentifier(account, clrSysMmbIdMaps);
                    if(clrSysMmbIdMaps.size()>0){
                        finInstnIdMaps.put("clrSysMmbId", clrSysMmbIdMaps);
                    }
                    if(finInstnIdMaps.size()>0){
                        cdtrAgtMaps.put("finInstnId", finInstnIdMaps);
                    }
                }
            }
            if(field58D != null){
                if (account.startsWith("//") && !account.startsWith("//CH")) {
                    Map<String, Object> finInstnIdMaps = MapUtil.getAndCreateNotPut(cdtrAgtMaps, "finInstnId");
                    Map<String, Object> clrSysMmbIdMaps = MapUtil.getAndCreateNotPut(finInstnIdMaps, "clrSysMmbId");
                    mt_to_mxClearingIdentifier(account, clrSysMmbIdMaps);
                    if (clrSysMmbIdMaps.size() > 0) {
                        finInstnIdMaps.put("clrSysMmbId", clrSysMmbIdMaps);
                    }
                    if (finInstnIdMaps.size() > 0) {
                        cdtrAgtMaps.put("finInstnId", finInstnIdMaps);
                    }
                }
                String nameAddress = field58D.getNameAndAddress();
                mt_to_mxFinancialInstitutionNameAndUnstructuredAddress(nameAddress, cdtrAgtMaps);
            }
        }
        if (field57A != null) {
            String bicCode = field57A.getBIC();
            mt_to_mxBICFI(bicCode, cdtrAgtMaps);
            if (StringUtil.isNotEmpty(field57A.getComponent1())) {
                account += "/" + field57A.getComponent1();
            }
            if (StringUtil.isNotEmpty(field57A.getComponent2())) {
                account += "/" + field57A.getComponent2();
            }
            if (account.startsWith("//") && !account.startsWith("//CH") && !account.startsWith("//FW") && !account.startsWith("//RT")) {
                Map<String, Object> finInstnIdMaps = MapUtil.getAndCreateNotPut(cdtrAgtMaps, "finInstnId");
                Map<String, Object> clrSysMmbIdMaps = MapUtil.getAndCreateNotPut(finInstnIdMaps, "clrSysMmbId");
                mt_to_mxClearingIdentifier(account, clrSysMmbIdMaps);
                if(clrSysMmbIdMaps.size()>0){
                    finInstnIdMaps.put("clrSysMmbId", clrSysMmbIdMaps);
                }
                if(finInstnIdMaps.size()>0){
                    cdtrAgtMaps.put("finInstnId", finInstnIdMaps);
                }
            } else if (!account.startsWith("//") || account.startsWith("//CH")) {
                mt_to_mxFinancialInstitutionAccount(account, cdtrAgtAcctMaps, "CdtrAgtAcct/Id");
            }
        } else if (field57B != null) {
            if (StringUtil.isNotEmpty(field57B.getComponent1())) {
                account += "/" + field57B.getComponent1();
            }
            if (StringUtil.isNotEmpty(field57B.getComponent2())) {
                account += "/" + field57B.getComponent2();
            }
            String location = field57B.getLocation();
            Map<String, Object> finInstnIdMaps = MapUtil.getAndCreateNotPut(cdtrAgtMaps, "finInstnId");
            if (account.startsWith("//") && !account.startsWith("//CH")) {
                if (isMTClearingSystemCodeInList(account)) {
                    Map<String, Object> clrSysMmbIdMaps = MapUtil.getAndCreateNotPut(finInstnIdMaps, "clrSysMmbId");
                    mt_to_mxClearingIdentifier(account, clrSysMmbIdMaps);
                    if(clrSysMmbIdMaps.size()>0){
                        finInstnIdMaps.put("clrSysMmbId",clrSysMmbIdMaps);
                    }
                    //name address 设置NOTPROVIDED
                    MapUtil.adds(finInstnIdMaps, "pstlAdr/adrLine", StringUtil.isEmpty(location)?Mx2MtConstants.MX_TO_MT_DEFAULT_VALUE:location);
                } else {
                    mt_to_mxClearingSystemToNameAndAddressLine(account, location, finInstnIdMaps, "CdtrAgt/FinInstnId");
                }
            } else if (!account.startsWith("//") || account.startsWith("//CH")) {
                mt_to_mxFinancialInstitutionAccount(account, cdtrAgtAcctMaps, "CdtrAgtAcct/Id");
                //name address 设置NOTPROVIDED
                finInstnIdMaps.put("nm", Mx2MtConstants.MX_TO_MT_DEFAULT_VALUE);
                MapUtil.adds(finInstnIdMaps, "pstlAdr/adrLine", StringUtil.isEmpty(location)?Mx2MtConstants.MX_TO_MT_DEFAULT_VALUE:location);
            }
            if(finInstnIdMaps.size()>0){
                cdtrAgtMaps.put("finInstnId",finInstnIdMaps);
            }
        } else if (field57C != null) {
            account = field57C.getValue();
            Map<String, Object> finInstnIdMaps = MapUtil.getAndCreateNotPut(cdtrAgtMaps, "finInstnId");
            if (account.startsWith("//") && !account.startsWith("//CH") && !account.startsWith("//FW")) {
                if (isMTClearingSystemCodeInList(account)) {
                    Map<String, Object> clrSysMmbIdMaps = MapUtil.getAndCreateNotPut(finInstnIdMaps, "clrSysMmbId");
                    mt_to_mxClearingIdentifier(account, clrSysMmbIdMaps);
                    if(clrSysMmbIdMaps.size()>0){
                        finInstnIdMaps.put("clrSysMmbId",clrSysMmbIdMaps);
                    }
                    //name address 设置NOTPROVIDED
                    finInstnIdMaps.put("nm", Mx2MtConstants.MX_TO_MT_DEFAULT_VALUE);
                    MapUtil.adds(finInstnIdMaps, "pstlAdr/adrLine", Mx2MtConstants.MT_TO_MX_DEFAULT_VALUE);
                } else {
                    mt_to_mxClearingSystemToNameAndAddressLine(account, null, finInstnIdMaps, "CdtrAgt/FinInstnId");
                }
            } else if (!account.startsWith("//") || account.startsWith("//CH")) {
                mt_to_mxFinancialInstitutionAccount(account, cdtrAgtAcctMaps, "CdtrAgtAcct/Id");
                if (StringUtil.isEmpty(account)) {
                    buildSTErrorInfo(14, "Block4/SeqB/:57B:", null);
                }
                //name address 设置NOTPROVIDED
                finInstnIdMaps.put("nm", Mx2MtConstants.MX_TO_MT_DEFAULT_VALUE);
                MapUtil.adds(finInstnIdMaps, "pstlAdr/adrLine", Mx2MtConstants.MT_TO_MX_DEFAULT_VALUE);
            }
            if(finInstnIdMaps.size()>0){
                cdtrAgtMaps.put("finInstnId",finInstnIdMaps);
            }
        } else if (field57D != null) {
            if (StringUtil.isNotEmpty(field57D.getComponent1())) {
                account += "/" + field57D.getComponent1();
            }
            if (StringUtil.isNotEmpty(field57D.getComponent2())) {
                account += "/" + field57D.getComponent2();
            }
            String nameAddress = field57D.getNameAndAddress();
            mt_to_mxFinancialInstitutionNameAndUnstructuredAddress(nameAddress, cdtrAgtMaps);
            if (account.startsWith("//") && !account.startsWith("//CH") && !account.startsWith("//FW")) {
                Map<String, Object> finInstnIdMaps = MapUtil.getAndCreateNotPut(cdtrAgtMaps, "finInstnId");
                Map<String, Object> clrSysMmbIdMaps = MapUtil.getAndCreateNotPut(finInstnIdMaps, "clrSysMmbId");
                mt_to_mxClearingIdentifier(account, clrSysMmbIdMaps);
                if(clrSysMmbIdMaps.size()>0){
                    finInstnIdMaps.put("clrSysMmbId", clrSysMmbIdMaps);
                }
                if(finInstnIdMaps.size()>0){
                    cdtrAgtMaps.put("finInstnId", finInstnIdMaps);
                }
            } else if (!account.startsWith("//") || account.startsWith("//CH")) {
                mt_to_mxFinancialInstitutionAccount(account, cdtrAgtAcctMaps, "CdtrAgtAcct/Id");
            }
        }
        if (cdtrAgtMaps.size() > 0) {
            undrlygCstmrCdtTrfMaps.put("cdtrAgt", cdtrAgtMaps);
        }
        if (cdtrAgtAcctMaps.size() > 0) {
            undrlygCstmrCdtTrfMaps.put("cdtrAgtAcct", cdtrAgtAcctMaps);
        }
    }
}
