package com.brilliance.swift.mx2element.pacs004001;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2element.AbstractMx2ElementCreator;
import com.brilliance.swift.util.XmlUtil;
import org.dom4j.Document;
import org.dom4j.DocumentException;
import org.dom4j.DocumentHelper;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

public class Mx2ElementPacs004001Creator extends AbstractMx2ElementCreator {
    @Override
    public Map<String, Object> buildElement() {
        return super.buildElement();
    }

    public Object buildStrdAddtlRmtInf() {
        try {
            Document document = DocumentHelper.parseText(xmlStr);
            Map<String, String> parentElementMaps = XmlUtil.getParentElementMaps(document);
            String bodyParentPath = parentElementMaps.get("Strd");
            List<String> list = new ArrayList<String>();
            int strdCount = XmlUtil.getChildrenCount(document, bodyParentPath + ".Strd", null);
            if (strdCount > 0) {
                for (int i = 0; i < strdCount; i++) {
                    int addtlRmtInfCount = XmlUtil.getChildrenCount(document, bodyParentPath + ".Strd(" + i + ").AddtlRmtInf", null);
                    if (addtlRmtInfCount > 0) {
                        for (int j = 0; j < addtlRmtInfCount; j++) {
                            String inf = XmlUtil.getXmlNodeValue(document, bodyParentPath + ".Strd(" + i + ").AddtlRmtInf(" + j + ")");
                            list.add(inf);
                        }
                    }
                }
            }
            if (list.size() > 0) {
                return list;
            } else {
                return null;
            }
        } catch (DocumentException e) {
            throw new SwiftException(e.getMessage());
        }
    }
}
