package com.brilliance.swift.mx2map.camt029;

import com.alibaba.fastjson.JSONArray;
import com.brilliance.swift.SwiftTransfer;
import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2map.AbstractMx2MapCreator;

import java.util.LinkedHashMap;
import java.util.Map;

public class Mx2MapCamt029Creator extends AbstractMx2MapCreator {
    @Override
    public Map<String, Object> mx2Map() throws SwiftException {
        Map<String, Object> elementMaps = SwiftTransfer.mx2ElementMaps(xmlStr);
        if (elementMaps.get("frBic") != null) {
            maps.put(getPropertyValue("app.header.sendBic"), elementMaps.get("frBic"));
        }
        if (elementMaps.get("toBic") != null) {
            maps.put(getPropertyValue("app.header.receiverBic"), elementMaps.get("toBic"));
        }
        String messageType = addSuffixWithMessageType(elementMaps);
        if (messageType != null) {
            maps.put(getPropertyValue("app.header.msgDefId"), messageType);
        }
        if (elementMaps.get("bizSvc") != null) {
            maps.put(getPropertyValue("app.header.bizSvc"), elementMaps.get("bizSvc"));
        }
        if (elementMaps.get("creDt") != null) {
            maps.put(getPropertyValue("app.header.creDt"), elementMaps.get("creDt"));
        }
        if (elementMaps.get("bizMsgIdr") != null) {
            maps.put(getPropertyValue("message.id"), elementMaps.get("bizMsgIdr"));
        }
        buildAgentInfo(maps, "assgnr", elementMaps);
        buildAgentInfo(maps, "assgne", elementMaps);
        if (elementMaps.get("stsConf") != null) {
            maps.put(Mx2MtConstants.NEW_LINE + getPropertyValue("stsConf"), elementMaps.get("stsConf"));
        }
        if (elementMaps.get("rsnCd") != null) {
            maps.put(getPropertyValue("rsnCd"), elementMaps.get("rsnCd"));
        }
        if (elementMaps.get("addtlInf") != null) {
            JSONArray jsonArray = (JSONArray)elementMaps.get("addtlInf");
            String rsnCdAddtlInf = "";
            for (int i=0; i< jsonArray.size(); i++) {
                if (i == 0) {
                    rsnCdAddtlInf += jsonArray.get(i);
                } else {
                    rsnCdAddtlInf += "," + jsonArray.get(i);
                }
            }
            maps.put(getPropertyValue("rsnCdAddtlInf"), rsnCdAddtlInf);
        }
        Map<String, Object> orgCreditTransferMaps = new LinkedHashMap<>();
        maps.put(Mx2MtConstants.NEW_LINE + getPropertyValue("orgCreditTransferInfo"), orgCreditTransferMaps);
        if (elementMaps.get("orgnlMsgId") != null) {
            orgCreditTransferMaps.put(getPropertyValue("orgnlMsgId"), elementMaps.get("orgnlMsgId"));
        }
        if (elementMaps.get("orgnlMsgNmId") != null) {
            orgCreditTransferMaps.put(getPropertyValue("orgnlMsgNmId"), elementMaps.get("orgnlMsgNmId"));
        }
        if (elementMaps.get("orgnlCreDtTm") != null) {
            orgCreditTransferMaps.put(getPropertyValue("orgnlCreDtTm"), elementMaps.get("orgnlCreDtTm"));
        }
        if (elementMaps.get("orgnlEndToEndId") != null) {
            orgCreditTransferMaps.put(getPropertyValue("orgnlEndToEndId"), elementMaps.get("orgnlEndToEndId"));
        }
        if (elementMaps.get("uetr") != null) {
            orgCreditTransferMaps.put(getPropertyValue("uetr"), elementMaps.get("uetr"));
        }
        return maps;
    }
}
