package com.brilliance.swift.mx2map.camt057;

import com.brilliance.swift.SwiftTransfer;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2map.AbstractMx2MapCreator;

import java.util.Map;

public class Mx2MapCamt057Creator extends AbstractMx2MapCreator {
    @Override
    public Map<String, Object> mx2Map() throws SwiftException {
        Map<String, Object> elementMaps = SwiftTransfer.mx2ElementMaps(xmlStr);
        if (elementMaps.get("frBic") != null) {
            maps.put(getPropertyValue("app.header.sendBic"), elementMaps.get("frBic"));
        }
        if (elementMaps.get("toBic") != null) {
            maps.put(getPropertyValue("app.header.receiverBic"), elementMaps.get("toBic"));
        }
        String messageType = addSuffixWithMessageType(elementMaps);
        if (messageType != null) {
            maps.put(getPropertyValue("app.header.msgDefId"), messageType);
        }
        if (elementMaps.get("bizSvc") != null) {
            maps.put(getPropertyValue("app.header.bizSvc"), elementMaps.get("bizSvc"));
        }
        if (elementMaps.get("creDt") != null) {
            maps.put(getPropertyValue("app.header.creDt"), elementMaps.get("creDt"));
        }
        if (elementMaps.get("acctId") != null) {
            maps.put(getPropertyValue("acctId"), elementMaps.get("acctId"));
        }
        if (elementMaps.get("itmId") != null) {
            maps.put(getPropertyValue("itmId"), elementMaps.get("itmId"));
        }
        if (elementMaps.get("itmUetr") != null) {
            maps.put(getPropertyValue("uetr"), elementMaps.get("itmUetr"));
        }
        if (elementMaps.get("itmCcy") != null) {
            maps.put(getPropertyValue("ccy"), elementMaps.get("itmCcy"));
        }
        if (elementMaps.get("itmAmt") != null) {
            maps.put(getPropertyValue("amt"), elementMaps.get("itmAmt"));
        }
        if (elementMaps.get("itmXpctdValDt") != null) {
            maps.put(getPropertyValue("itmXpctdValDt"), elementMaps.get("itmXpctdValDt"));
        }
        buildAgentInfo(maps, "acctOwnrAgt", elementMaps);
        buildAgentInfo(maps, "acctSvcr", elementMaps);
        buildPartyInfo(maps, "dbtrPty", elementMaps);
        buildAgentInfo(maps, "dbtrAgt", elementMaps);
        buildAgentInfo(maps, "intrmyAgt", elementMaps);
        return maps;
    }
}
