package com.brilliance.swift.mx2map.pacs002;

import com.brilliance.swift.SwiftTransfer;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2map.AbstractMx2MapCreator;

import java.util.Map;

public class Mx2MapPacs002Creator extends AbstractMx2MapCreator {
    @Override
    public Map<String, Object> mx2Map() throws SwiftException {
        Map<String, Object> elementMaps = SwiftTransfer.mx2ElementMaps(xmlStr);
        if (elementMaps.get("frBic") != null) {
            maps.put(getPropertyValue("app.header.sendBic"), elementMaps.get("frBic"));
        }
        if (elementMaps.get("toBic") != null) {
            maps.put(getPropertyValue("app.header.receiverBic"), elementMaps.get("toBic"));
        }
        String messageType = addSuffixWithMessageType(elementMaps);
        if (messageType != null) {
            maps.put(getPropertyValue("app.header.msgDefId"), messageType);
        }
        if (elementMaps.get("bizSvc") != null) {
            maps.put(getPropertyValue("app.header.bizSvc"), elementMaps.get("bizSvc"));
        }
        if (elementMaps.get("creDt") != null) {
            maps.put(getPropertyValue("app.header.creDt"), elementMaps.get("creDt"));
        }

        if (elementMaps.get("endToEndId") != null) {
            maps.put(getPropertyValue("endToEnd.id"), elementMaps.get("endToEndId"));
        }
        if (elementMaps.get("uetr") != null) {
            maps.put(getPropertyValue("uetr"), elementMaps.get("uetr"));
        }
        if (elementMaps.get("orgnlMsgId") != null) {
            maps.put(getPropertyValue("orgnlMsgId"), elementMaps.get("orgnlMsgId"));
        }
        if (elementMaps.get("orgnlMsgNmId") != null) {
            maps.put(getPropertyValue("orgnlMsgNmId"), elementMaps.get("orgnlMsgNmId"));
        }
        if (elementMaps.get("orgnlCreDtTm") != null) {
            maps.put(getPropertyValue("orgnlCreDtTm"), elementMaps.get("orgnlCreDtTm"));
        }
        if (elementMaps.get("orgnlEndToEndId") != null) {
            maps.put(getPropertyValue("orgnlEndToEndId"), elementMaps.get("orgnlEndToEndId"));
        }
        if (elementMaps.get("orgnlUETR") != null) {
            maps.put(getPropertyValue("orgnlUETR"), elementMaps.get("orgnlUETR"));
        }
        if (elementMaps.get("orgtrNm") != null) {
            maps.put(getPropertyValue("orgtrNm"), elementMaps.get("orgtrNm"));
        }
        if (elementMaps.get("rsnCd") != null) {
            maps.put(getPropertyValue("rsnCd"), elementMaps.get("rsnCd"));
        }
        if (elementMaps.get("txSts") != null) {
            maps.put(getPropertyValue("txSts"), elementMaps.get("txSts"));
        }
        if (elementMaps.get("clrSysRef") != null) {
            maps.put(getPropertyValue("clrSysRef"), elementMaps.get("clrSysRef"));
        }
        if (elementMaps.get("fctvIntrBkSttlmDt") != null) {
            maps.put(getPropertyValue("fctvIntrBkSttlmDt"), elementMaps.get("fctvIntrBkSttlmDt"));
        }
        return maps;
    }
}
