package com.brilliance.swift.mx2map.pacs004;

import com.brilliance.swift.SwiftTransfer;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2map.AbstractMx2MapCreator;

import java.util.Map;

public class Mx2MapPacs004Creator extends AbstractMx2MapCreator {
    @Override
    public Map<String, Object> mx2Map() throws SwiftException {
        Map<String, Object> elementMaps = SwiftTransfer.mx2ElementMaps(xmlStr);
        if (elementMaps.get("frBic") != null) {
            maps.put(getPropertyValue("app.header.sendBic"), elementMaps.get("frBic"));
        }
        if (elementMaps.get("toBic") != null) {
            maps.put(getPropertyValue("app.header.receiverBic"), elementMaps.get("toBic"));
        }
        String messageType = addSuffixWithMessageType(elementMaps);
        if (messageType != null) {
            maps.put(getPropertyValue("app.header.msgDefId"), messageType);
        }
        if (elementMaps.get("bizSvc") != null) {
            maps.put(getPropertyValue("app.header.bizSvc"), elementMaps.get("bizSvc"));
        }
        if (elementMaps.get("creDt") != null) {
            maps.put(getPropertyValue("app.header.creDt"), elementMaps.get("creDt"));
        }

        if (elementMaps.get("endToEndId") != null) {
            maps.put(getPropertyValue("endToEnd.id"), elementMaps.get("endToEndId"));
        }
        if (elementMaps.get("uetr") != null) {
            maps.put(getPropertyValue("uetr"), elementMaps.get("uetr"));
        }
        if (elementMaps.get("nbOfTxs") != null) {
            maps.put(getPropertyValue("nbOfTxs"), elementMaps.get("nbOfTxs"));
        }
        if (elementMaps.get("sttlmMtd") != null) {
            maps.put(getPropertyValue("statement.id"), elementMaps.get("sttlmMtd"));
        }
        if (elementMaps.get("orgnlEndToEndId") != null) {
            maps.put(getPropertyValue("orgnlEndToEndId"), elementMaps.get("orgnlEndToEndId"));
        }
        if (elementMaps.get("orgnlUETR") != null) {
            maps.put(getPropertyValue("orgnlUETR"), elementMaps.get("orgnlUETR"));
        }
        if (elementMaps.get("orgnlIntrBkSttlmAmt") != null) {
            maps.put(getPropertyValue("orgnlIntrBkSttlmAmt"), elementMaps.get("orgnlIntrBkSttlmAmt"));
        }
        if (elementMaps.get("orgnlIntrBkSttlmCcy") != null) {
            maps.put(getPropertyValue("orgnlIntrBkSttlmCcy"), elementMaps.get("orgnlIntrBkSttlmCcy"));
        }
        if (elementMaps.get("rtrdIntrBkSttlmAmt") != null) {
            maps.put(getPropertyValue("rtrdIntrBkSttlmAmt"), elementMaps.get("rtrdIntrBkSttlmAmt"));
        }
        if (elementMaps.get("rtrdIntrBkSttlmCcy") != null) {
            maps.put(getPropertyValue("rtrdIntrBkSttlmCcy"), elementMaps.get("rtrdIntrBkSttlmCcy"));
        }
        if (elementMaps.get("intrBkSttlmDt") != null) {
            maps.put(getPropertyValue("intrBkSttlmDt"), elementMaps.get("intrBkSttlmDt"));
        }
        if (elementMaps.get("chrgBr") != null) {
            maps.put(getPropertyValue("chrgBr"), elementMaps.get("chrgBr"));
        }
        if (elementMaps.get("instgAgtBicfi") != null) {
            maps.put(getPropertyValue("instgAgtBicfi"), elementMaps.get("instgAgtBicfi"));
        }
        if (elementMaps.get("instdAgtBicfi") != null) {
            maps.put(getPropertyValue("instdAgtBicfi"), elementMaps.get("instdAgtBicfi"));
        }
        Map<String, Object> dbtrPty = (Map) elementMaps.get("dbtrPty");
        if (dbtrPty != null) {
            if (dbtrPty.get("nm") != null) {
                maps.put(getPropertyValue("dbtrNm"), dbtrPty.get("nm"));
            }
        }
        Map<String, Object> cdtrPty = (Map) elementMaps.get("dbtrPty");
        if (cdtrPty != null) {
            if (cdtrPty.get("nm") != null) {
                maps.put(getPropertyValue("cdtrNm"), cdtrPty.get("nm"));
            }
        }
        if (elementMaps.get("rsnCd") != null) {
            maps.put(getPropertyValue("rsnCd"), elementMaps.get("rsnCd"));
        }
        return maps;
    }
}
