package com.brilliance.swift.mx2message.camt029;

import com.alibaba.fastjson.JSONArray;
import com.brilliance.swift.SwiftTransfer;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2message.AbstractMx2MessageCreator;

import java.util.Map;

public class Mx2MessageCamt029Creator extends AbstractMx2MessageCreator {
    @Override
    public String mx2Message() throws SwiftException {
        Map<String, Object> elementMaps = SwiftTransfer.mx2ElementMaps(xmlStr);
        getAppHdrMessage(elementMaps);
        buildAgentInfo( "assgnr", elementMaps);
        buildAgentInfo( "assgne", elementMaps);
        if (elementMaps.get("stsConf") != null) {
            maps.put("stsConf", elementMaps.get("stsConf"));
        }
        if (elementMaps.get("rsnCd") != null) {
            maps.put("rsnCd", elementMaps.get("rsnCd"));
        }
        if (elementMaps.get("addtlInf") != null) {
            JSONArray jsonArray = (JSONArray) elementMaps.get("addtlInf");
            String rsnCdAddtlInf = "";
            for (int i = 0; i < jsonArray.size(); i++) {
                if (i == 0) {
                    rsnCdAddtlInf += jsonArray.get(i);
                } else {
                    rsnCdAddtlInf += "," + jsonArray.get(i);
                }
            }
            maps.put("rsnCdAddtlInf", rsnCdAddtlInf);
        }
        if(elementMaps.get("orgnlMsgId") != null||elementMaps.get("orgnlMsgNmId") != null
        ||elementMaps.get("orgnlCreDtTm") != null||elementMaps.get("orgnlEndToEndId") != null
        ||elementMaps.get("uetr") != null){
            maps.put("orgCreditTransferInfo", "true");
        }
        if (elementMaps.get("orgnlMsgId") != null) {
            maps.put("orgnlMsgId", elementMaps.get("orgnlMsgId"));
        }
        if (elementMaps.get("orgnlMsgNmId") != null) {
            maps.put("orgnlMsgNmId", elementMaps.get("orgnlMsgNmId"));
        }
        if (elementMaps.get("orgnlCreDtTm") != null) {
            maps.put("orgnlCreDtTm", elementMaps.get("orgnlCreDtTm"));
        }
        if (elementMaps.get("orgnlEndToEndId") != null) {
            maps.put("orgnlEndToEndId", elementMaps.get("orgnlEndToEndId"));
        }
        if (elementMaps.get("uetr") != null) {
            maps.put("uetr", elementMaps.get("uetr"));
        }
        return process();
    }
}