package com.brilliance.swift.mx2message.camt053;

import com.brilliance.swift.SwiftTransfer;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2message.AbstractMx2MessageCreator;

import java.math.BigDecimal;
import java.util.Map;

public class Mx2MessageCamt053Creator extends AbstractMx2MessageCreator {
    @Override
    public String mx2Message() throws SwiftException {
        Map<String, Object> elementMaps = SwiftTransfer.mx2ElementMaps(xmlStr);
        getAppHdrMessage(elementMaps);
        if (elementMaps.get("acctIdIban") != null) {
            maps.put("acctIdIban", elementMaps.get("acctIdIban"));
        }
        if (elementMaps.get("acctId") != null) {
            maps.put("acctId", elementMaps.get("acctId"));
        }
        if (elementMaps.get("acctCcy") != null) {
            maps.put("acctCcy", elementMaps.get("acctCcy"));
        }
        if (elementMaps.get("lglSeqNb") != null) {
            maps.put("lglSeqNb", elementMaps.get("lglSeqNb"));
        }
        if (elementMaps.get("pgNb") != null) {
            maps.put("pgNb", elementMaps.get("pgNb"));
        }
        if (elementMaps.get("lastPgInd") != null) {
            Boolean lastPgInd = (Boolean)elementMaps.get("lastPgInd");
            maps.put("lastPgInd", lastPgInd ? getPropertyValue("yes") : getPropertyValue("no"));
        } else {
            maps.put("lastPgInd", getPropertyValue("no"));
        }
        //期初余额
        if (elementMaps.get("opbdBalCdtDbtInd") != null) {
            maps.put("opbdBalCdtDbtInd", elementMaps.get("opbdBalCdtDbtInd"));
        }
        if (elementMaps.get("opbdBalDt") != null) {
            maps.put("opbdBalDt", elementMaps.get("opbdBalDt"));
        }
        if (elementMaps.get("opbdBalCcy") != null) {
            maps.put("opbdBalCcy", elementMaps.get("opbdBalCcy"));
        }
        if (elementMaps.get("opbdBalAmt") != null) {
            BigDecimal amt = (BigDecimal)elementMaps.get("opbdBalAmt");
            maps.put("opbdBalAmt", amt.toPlainString());
        }
        if (elementMaps.get("ntry") != null) {
            maps.put("ntry",elementMaps.get("ntry"));
        }
        //期末余额
        if (elementMaps.get("clbdBalCdtDbtInd") != null) {
            maps.put("clbdBalCdtDbtInd", elementMaps.get("clbdBalCdtDbtInd"));
        }
        if (elementMaps.get("clbdBalDt") != null) {
            maps.put("clbdBalDt", elementMaps.get("clbdBalDt"));
        }
        if (elementMaps.get("clbdBalCcy") != null) {
            maps.put("clbdBalCcy", elementMaps.get("clbdBalCcy"));
        }
        if (elementMaps.get("clbdBalAmt") != null) {
            BigDecimal amt = (BigDecimal) elementMaps.get("clbdBalAmt");
            maps.put("clbdBalAmt", amt.toPlainString());
        }
        return process();
    }
}
