package com.brilliance.swift.mx2message.camt054;

import com.brilliance.swift.SwiftTransfer;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2message.AbstractMx2MessageCreator;

import java.math.BigDecimal;
import java.util.Map;

public class Mx2MessageCamt054Creator extends AbstractMx2MessageCreator {
    @Override
    public String mx2Message() throws SwiftException {
        Map<String, Object> elementMaps = SwiftTransfer.mx2ElementMaps(xmlStr);
        getAppHdrMessage(elementMaps);
        if (elementMaps.get("endToEndId") != null) {
            maps.put("endToEndId", elementMaps.get("endToEndId"));
        }
        if (elementMaps.get("uetr") != null) {
            maps.put("uetr", elementMaps.get("uetr"));
        }
        if (elementMaps.get("cdtDbtInd") != null) {
            maps.put("cdtDbtInd", elementMaps.get("cdtDbtInd"));
        }
        if (elementMaps.get("sts") != null) {
            maps.put("status", elementMaps.get("sts"));
        } else if (elementMaps.get("stsPrtry") != null) {
            maps.put("status", elementMaps.get("stsPrtry"));
        }
        if (elementMaps.get("bookgDt") != null) {
            maps.put("bookgDt", elementMaps.get("bookgDt"));
        }
        if (elementMaps.get("valDt") != null) {
            maps.put("valDt", elementMaps.get("valDt"));
        }
        if (elementMaps.get("ntryAmt") != null) {
            BigDecimal amt = (BigDecimal) elementMaps.get("ntryAmt");
            if (elementMaps.get("ntryCcy") != null) {
                maps.put("valueAmt", elementMaps.get("ntryCcy") + " " + amt.toPlainString());
            } else {
                maps.put("valueAmt", amt.toPlainString());
            }
        }
        if (elementMaps.get("ntfctnAcctIdIban") != null) {
            maps.put("ntfctnAcctIdIban", elementMaps.get("ntfctnAcctIdIban"));
        }
        if (elementMaps.get("ntfctnAcctId") != null) {
            maps.put("ntfctnAcctId", elementMaps.get("ntfctnAcctId"));
        }
        if (elementMaps.get("ntfctnAcctCcy") != null) {
            maps.put("ntfctnAcctCcy", elementMaps.get("ntfctnAcctCcy"));
        }
        buildPartyInfo("dbtr", elementMaps);
        buildAgentInfo("dbtrAgt", elementMaps);
        buildAgentInfo("intrmyAgt1", elementMaps);
        if (elementMaps.get("addtlTxInf") != null) {
            maps.put("addtlTxInf", elementMaps.get("addtlTxInf"));
        }
        return process();
    }
}
