package com.brilliance.swift.mx2message.pacs004;

import com.brilliance.swift.SwiftTransfer;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2message.AbstractMx2MessageCreator;

import java.util.Map;

public class Mx2MessagePacs004Creator extends AbstractMx2MessageCreator {
    @Override
    public String mx2Message() throws SwiftException {
        Map<String, Object> elementMaps = SwiftTransfer.mx2ElementMaps(xmlStr);
        getAppHdrMessage(elementMaps);
        if (elementMaps.get("endToEndId") != null) {
            maps.put("endToEndId", elementMaps.get("endToEndId"));
        }
        if (elementMaps.get("uetr") != null) {
            maps.put("uetr", elementMaps.get("uetr"));
        }
        if (elementMaps.get("nbOfTxs") != null) {
            maps.put("nbOfTxs", elementMaps.get("nbOfTxs"));
        }
        if (elementMaps.get("sttlmMtd") != null) {
            maps.put("sttlmMtd", elementMaps.get("sttlmMtd"));
        }
        if (elementMaps.get("orgnlEndToEndId") != null) {
            maps.put("orgnlEndToEndId", elementMaps.get("orgnlEndToEndId"));
        }
        if (elementMaps.get("orgnlUETR") != null) {
            maps.put("orgnlUETR", elementMaps.get("orgnlUETR"));
        }
        if (elementMaps.get("orgnlIntrBkSttlmAmt") != null) {
            maps.put("orgnlIntrBkSttlmAmt", elementMaps.get("orgnlIntrBkSttlmAmt"));
        }
        if (elementMaps.get("orgnlIntrBkSttlmCcy") != null) {
            maps.put("orgnlIntrBkSttlmCcy", elementMaps.get("orgnlIntrBkSttlmCcy"));
        }
        if (elementMaps.get("rtrdIntrBkSttlmAmt") != null) {
            maps.put("rtrdIntrBkSttlmAmt", elementMaps.get("rtrdIntrBkSttlmAmt"));
        }
        if (elementMaps.get("rtrdIntrBkSttlmCcy") != null) {
            maps.put("rtrdIntrBkSttlmCcy", elementMaps.get("rtrdIntrBkSttlmCcy"));
        }
        if (elementMaps.get("intrBkSttlmDt") != null) {
            maps.put("intrBkSttlmDt", elementMaps.get("intrBkSttlmDt"));
        }
        if (elementMaps.get("chrgBr") != null) {
            maps.put("chrgBr", elementMaps.get("chrgBr"));
        }
        if (elementMaps.get("instgAgtBicfi") != null) {
            maps.put("instgAgtBicfi", elementMaps.get("instgAgtBicfi"));
        }
        if (elementMaps.get("instdAgtBicfi") != null) {
            maps.put("instdAgtBicfi", elementMaps.get("instdAgtBicfi"));
        }
        Map<String, Object> dbtrPty = (Map) elementMaps.get("dbtrPty");
        if (dbtrPty != null) {
            if (dbtrPty.get("nm") != null) {
                maps.put("dbtrNm", dbtrPty.get("nm"));
            }
        }
        Map<String, Object> cdtrPty = (Map) elementMaps.get("dbtrPty");
        if (cdtrPty != null) {
            if (cdtrPty.get("nm") != null) {
                maps.put("cdtrNm", cdtrPty.get("nm"));
            }
        }
        if (elementMaps.get("rsnCd") != null) {
            maps.put("rsnCd", elementMaps.get("rsnCd"));
        }
        return process();
    }
}
