package com.brilliance.swift.mx2mt.mt292.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.DateUtil;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import javax.xml.datatype.DatatypeConfigurationException;
import javax.xml.datatype.DatatypeFactory;
import javax.xml.datatype.XMLGregorianCalendar;
import java.util.List;

/**
 *
 */
public class Field11SGenerate extends AbstractMx2MtTagsGenerate {

    private static String name = "11S";

    @Override
    public void tagGenerate() throws SwiftException {
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        String field11S = "210";
        String mtDate = "991231";
        String dateStr = getXmlNodeValue(bodyHdrParentElementName, document, "OrgnlNtfctn.OrgnlCreDtTm");
        if (StringUtil.isNotEmpty(dateStr)) {
            try {
                XMLGregorianCalendar date = DatatypeFactory.newInstance().newXMLGregorianCalendar(dateStr);
                mtDate = DateUtil.format(date, "yyMMdd");
            } catch (DatatypeConfigurationException e) {
                throw new SwiftException(e.getMessage());
            }
        }
        if("991231".equals(mtDate)){
            buildSTErrorInfo(119,"Block4/:11S:",mtDate);
        }
        tags.add(new Tag(name, field11S + Mx2MtConstants.NEW_LINE + mtDate));
    }
}
