package com.brilliance.swift.mx2mt.mt292.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;

/**
 * 取值逻辑：
 * field21 = OrgnlNtfctn.OrgnlNtfctnRef.OrgnlItm.OrgnlItmId,如果长度大于16，field21 = field21截取15位 + 最后一位用+代替
 * 如果filed21 以/开始或者以/结束或者包含//，field21=NONREF
 * 否则保持原值不变
 */
public class Field21Generate extends AbstractMx2MtTagsGenerate {

    private static String name = "21";

    @Override
    public void tagGenerate() throws SwiftException {
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        int orgnlItmCount = getXmlNodeCounts(bodyHdrParentElementName, document, "OrgnlNtfctn.OrgnlNtfctnRef.OrgnlItm");
        if(orgnlItmCount>0){
            String orgnlItmId = getXmlNodeValue(bodyHdrParentElementName, document, "OrgnlNtfctn.OrgnlNtfctnRef.OrgnlItm(0).OrgnlItmId");
            if (StringUtil.isNotEmpty(orgnlItmId)) {
                if (orgnlItmId.length() > 16) {
                    buildSTErrorInfo(13, "Block4/:21:", orgnlItmId);
                    orgnlItmId = orgnlItmId.substring(0, 15) + "+";
                }
                tags.add(new Tag(name, orgnlItmId));
            }
        }
    }
}
