package com.brilliance.swift.mx2mt.mt292.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.DateUtil;
import com.brilliance.swift.util.NumberUtil;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field121;

import javax.xml.datatype.DatatypeConfigurationException;
import javax.xml.datatype.DatatypeFactory;
import javax.xml.datatype.XMLGregorianCalendar;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**

 */
public class Field79Generate extends AbstractMx2MtTagsGenerate {

    private static String name_79 = "79";

    private static String name_30 = "30";

    private static String name_32 = "32B";

    @Override
    public void tagGenerate() throws SwiftException {
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        boolean flag30 = false;
        boolean flag32B = false;
        String mtValDtStr = "";
        String amtStr = "";
        String ccyStr = "";
        int orgnlItmCount = getXmlNodeCounts(bodyHdrParentElementName, document, "OrgnlNtfctn.OrgnlNtfctnRef.OrgnlItm");
        if(orgnlItmCount>0){
            String valDtStr = getXmlNodeValue(bodyHdrParentElementName, document, "OrgnlNtfctn.OrgnlNtfctnRef.OrgnlItm(0).XpctdValDt");
            if (StringUtil.isNotEmpty(valDtStr)) {
                try {
                    XMLGregorianCalendar valDt = DatatypeFactory.newInstance().newXMLGregorianCalendar(valDtStr);
                    mtValDtStr = DateUtil.format(valDt, "yyMMdd");
                    flag30 = true;
                } catch (DatatypeConfigurationException e) {
                    throw new SwiftException(e.getMessage());
                }
            }
            amtStr = getXmlNodeValue(bodyHdrParentElementName, document, "OrgnlNtfctn.OrgnlNtfctnRef.OrgnlItm(0).Amt");
            ccyStr = getXmlNodeValue(bodyHdrParentElementName, document, "OrgnlNtfctn.OrgnlNtfctnRef.OrgnlItm(0).Amt@Ccy");
            if (StringUtil.isNotEmpty(amtStr) && StringUtil.isNotEmpty(ccyStr)) {
                if (NumberUtil.judgeAmtStrExceedLength(amtStr, 14)) {
                    buildSTErrorInfo(36, "Block4/:"+name_32+":", amtStr);
                }
                flag32B = true;
            }
            String uetr = getXmlNodeValue(bodyHdrParentElementName2, document, "OrgnlNtfctn.OrgnlNtfctnRef.OrgnlItm(0).UETR");
            String mxReasonCode = getXmlNodeValue(bodyHdrParentElementName2, document, "CxlRsn.Rsn.Cd");
            int addtlInfCount = getXmlNodeCounts(bodyHdrParentElementName2, document, "CxlRsn.AddtlInf");
            String mxAddtlInf = "";
            if (addtlInfCount > 0) {
                for (int i=0; i<addtlInfCount; i++) {
                    if (i == 2) break;
                    String addtlInf = getXmlNodeValue(bodyHdrParentElementName2, document, "CxlRsn.AddtlInf("+i+")");
                    if (i == 0) {
                        mxAddtlInf += addtlInf;
                    } else {
                        if (getXmlNodeValue(bodyHdrParentElementName2, document, "CxlRsn.AddtlInf("+(i-1)+")").length() > 104) {
                            mxAddtlInf += addtlInf;
                        } else {
                            mxAddtlInf += " " + addtlInf;
                        }
                    }
                }
            }
            String mt79 = "";
            if(StringUtil.isNotEmpty(mxReasonCode)){
                if(StringUtil.isNotEmpty(mxAddtlInf)&&mxAddtlInf.length()>=6){
                    Pattern r = Pattern.compile("/[0-9,A-Z]{4}/");
                    Matcher m = r.matcher(mxAddtlInf.substring(0,6));
                    if("NARR".equals(mxReasonCode)&&m.matches()){
                        mt79 += mxAddtlInf;
                    }else {
                        mt79 += "/" + mxReasonCode + "/" + mxAddtlInf;
                    }
                }
            }
            List<String> list = new ArrayList<>();
            if (StringUtil.isNotEmpty(mt79)) {
                list.addAll(StringUtil.outStringList(mt79, 50, "//"));
            }
            if(StringUtil.isNotEmpty(uetr)){
                list.add("/UETR/" + uetr);
            }
            String value = "";
            for (int i=0; i<list.size(); i++) {
                if (i == 35) break;
                if (i == 0) {
                    value = list.get(i);
                } else {
                    value += Mx2MtConstants.NEW_LINE + list.get(i);
                }
            }
            value = mx_to_mtStartingLineCharacter(value, "Block4/:79:");
            tags.add(new Tag(name_79, value));
            if(StringUtil.isNotEmpty(value)){
                if(flag30){
                    tags.add(new Tag(name_30, mtValDtStr));
                }
                if(flag32B){
                    tags.add(new Tag(name_32, ccyStr + NumberUtil.formatAmt(new BigDecimal(amtStr), ccyStr)));
                }
            }
        }
    }
}
